# TencentAds\AdcreativePreviewsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**adcreativePreviewsAdd**](AdcreativePreviewsApi.md#adcreativePreviewsAdd) | **POST** /adcreative_previews/add | 创建预览
[**adcreativePreviewsGet**](AdcreativePreviewsApi.md#adcreativePreviewsGet) | **GET** /adcreative_previews/get | 获取预览受众


# **adcreativePreviewsAdd**
> \TencentAds\Model\AdcreativePreviewsAddResponse adcreativePreviewsAdd($data)

创建预览

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AdcreativePreviewsAddRequest(); // \TencentAds\Model\AdcreativePreviewsAddRequest | 

try {
    $result = $tads->adcreativePreviews()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling adcreativePreviews()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AdcreativePreviewsAddRequest**](../Model/AdcreativePreviewsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\AdcreativePreviewsAddResponse**](../Model/AdcreativePreviewsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **adcreativePreviewsGet**
> \TencentAds\Model\AdcreativePreviewsList adcreativePreviewsGet($accountId, $filtering, $fields)

获取预览受众

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\AdPowerPreviewFilteringStruct()); // \TencentAds\Model\AdPowerPreviewFilteringStruct[] | 过滤条件
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->adcreativePreviews()->get($accountId, $filtering, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling adcreativePreviews()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **filtering** | [**\TencentAds\Model\AdPowerPreviewFilteringStruct[]**](../Model/\TencentAds\Model\AdPowerPreviewFilteringStruct.md)| 过滤条件 |
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\AdcreativePreviewsList**](../Model/AdcreativePreviewsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

