# TencentAds\AdcreativeTemplateDetailApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**adcreativeTemplateDetailGet**](AdcreativeTemplateDetailApi.md#adcreativeTemplateDetailGet) | **GET** /adcreative_template_detail/get | 获取创意规格信息


# **adcreativeTemplateDetailGet**
> \TencentAds\Model\AdcreativeTemplateDetailsList adcreativeTemplateDetailGet($adcreativeTemplateId, $promotedObjectType, $accountId, $automaticSiteEnabled, $siteSet, $isDynamicCreativeAd, $fields)

获取创意规格信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$adcreativeTemplateId = 789; // int | 创意形式id
$promotedObjectType = "promotedObjectType_example"; // string | 推广目标类型
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$automaticSiteEnabled = true; // bool | 是否开启自动版位功能（暂不包含SITE_SET_WECHAT），此字段与 site_set 字段至少需要写入一个。该功能目前灰度中。
$siteSet = array("siteSet_example"); // string[] | 投放站点集合，当前单站点或者 SITE_SET_TENCENT_NEWS+SITE_SET_TENCENT_VIDEO的组合
$isDynamicCreativeAd = true; // bool | 是否查询这个规格在动态创意广告类型下可用的创意元素adcreative elements，选填值，不填则默认查询常规展示广告所用的元素，设置为True时查询动态创意广告相关元素
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->adcreativeTemplateDetail()->get($adcreativeTemplateId, $promotedObjectType, $accountId, $automaticSiteEnabled, $siteSet, $isDynamicCreativeAd, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling adcreativeTemplateDetail()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **adcreativeTemplateId** | **int**| 创意形式id |
 **promotedObjectType** | **string**| 推广目标类型 |
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id | [optional]
 **automaticSiteEnabled** | **bool**| 是否开启自动版位功能（暂不包含SITE_SET_WECHAT），此字段与 site_set 字段至少需要写入一个。该功能目前灰度中。 | [optional]
 **siteSet** | [**string[]**](../Model/string.md)| 投放站点集合，当前单站点或者 SITE_SET_TENCENT_NEWS+SITE_SET_TENCENT_VIDEO的组合 | [optional]
 **isDynamicCreativeAd** | **bool**| 是否查询这个规格在动态创意广告类型下可用的创意元素adcreative elements，选填值，不填则默认查询常规展示广告所用的元素，设置为True时查询动态创意广告相关元素 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\AdcreativeTemplateDetailsList**](../Model/AdcreativeTemplateDetailsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

