# TencentAds\AdcreativesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**adcreativesAdd**](AdcreativesApi.md#adcreativesAdd) | **POST** /adcreatives/add | 创建广告创意
[**adcreativesDelete**](AdcreativesApi.md#adcreativesDelete) | **POST** /adcreatives/delete | 删除广告创意
[**adcreativesGet**](AdcreativesApi.md#adcreativesGet) | **GET** /adcreatives/get | 获取广告创意
[**adcreativesUpdate**](AdcreativesApi.md#adcreativesUpdate) | **POST** /adcreatives/update | 更新广告创意


# **adcreativesAdd**
> \TencentAds\Model\AdCreativesAddResponse adcreativesAdd($data)

创建广告创意

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AdCreativesAddRequest(); // \TencentAds\Model\AdCreativesAddRequest | 

try {
    $result = $tads->adcreatives()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling adcreatives()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AdCreativesAddRequest**](../Model/AdCreativesAddRequest.md)|  |

### Return type

[**\TencentAds\Model\AdCreativesAddResponse**](../Model/AdCreativesAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **adcreativesDelete**
> \TencentAds\Model\AdCreativesDeleteResponse adcreativesDelete($data)

删除广告创意

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AdCreativesDeleteRequest(); // \TencentAds\Model\AdCreativesDeleteRequest | 

try {
    $result = $tads->adcreatives()->delete($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling adcreatives()->delete(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AdCreativesDeleteRequest**](../Model/AdCreativesDeleteRequest.md)|  |

### Return type

[**\TencentAds\Model\AdCreativesDeleteResponse**](../Model/AdCreativesDeleteResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **adcreativesGet**
> \TencentAds\Model\AdCreativesList adcreativesGet($accountId, $filtering, $page, $pageSize, $isDeleted, $fields)

获取广告创意

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\AdCreativeFilteringStruct()); // \TencentAds\Model\AdCreativeFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$isDeleted = true; // bool | 是否已删除
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->adcreatives()->get($accountId, $filtering, $page, $pageSize, $isDeleted, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling adcreatives()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **filtering** | [**\TencentAds\Model\AdCreativeFilteringStruct[]**](../Model/\TencentAds\Model\AdCreativeFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **isDeleted** | **bool**| 是否已删除 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\AdCreativesList**](../Model/AdCreativesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **adcreativesUpdate**
> \TencentAds\Model\AdCreativesUpdateResponse adcreativesUpdate($data)

更新广告创意

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AdCreativesUpdateRequest(); // \TencentAds\Model\AdCreativesUpdateRequest | 

try {
    $result = $tads->adcreatives()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling adcreatives()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AdCreativesUpdateRequest**](../Model/AdCreativesUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\AdCreativesUpdateResponse**](../Model/AdCreativesUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

