# TencentAds\AdcreativesRelatedCapabilityApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**adcreativesRelatedCapabilityGet**](AdcreativesRelatedCapabilityApi.md#adcreativesRelatedCapabilityGet) | **GET** /adcreatives_related_capability/get | 检查广告创意是否可以修改


# **adcreativesRelatedCapabilityGet**
> \TencentAds\Model\AdcreativesRelatedCapabilityList adcreativesRelatedCapabilityGet($accountId, $adId, $fields)

检查广告创意是否可以修改

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$adId = 789; // int | 广告 id
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->adcreativesRelatedCapability()->get($accountId, $adId, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling adcreativesRelatedCapability()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **adId** | **int**| 广告 id |
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\AdcreativesRelatedCapabilityList**](../Model/AdcreativesRelatedCapabilityList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

