# TencentAds\AdgroupsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**adgroupsAdd**](AdgroupsApi.md#adgroupsAdd) | **POST** /adgroups/add | 创建广告组
[**adgroupsDelete**](AdgroupsApi.md#adgroupsDelete) | **POST** /adgroups/delete | 删除广告组
[**adgroupsGet**](AdgroupsApi.md#adgroupsGet) | **GET** /adgroups/get | 获取广告组
[**adgroupsUpdate**](AdgroupsApi.md#adgroupsUpdate) | **POST** /adgroups/update | 更新广告组


# **adgroupsAdd**
> \TencentAds\Model\AdgroupsAddResponse adgroupsAdd($data)

创建广告组

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AdgroupsAddRequest(); // \TencentAds\Model\AdgroupsAddRequest | 

try {
    $result = $tads->adgroups()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling adgroups()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AdgroupsAddRequest**](../Model/AdgroupsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\AdgroupsAddResponse**](../Model/AdgroupsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **adgroupsDelete**
> \TencentAds\Model\AdgroupsDeleteResponse adgroupsDelete($data)

删除广告组

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AdgroupsDeleteRequest(); // \TencentAds\Model\AdgroupsDeleteRequest | 

try {
    $result = $tads->adgroups()->delete($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling adgroups()->delete(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AdgroupsDeleteRequest**](../Model/AdgroupsDeleteRequest.md)|  |

### Return type

[**\TencentAds\Model\AdgroupsDeleteResponse**](../Model/AdgroupsDeleteResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **adgroupsGet**
> \TencentAds\Model\AdgroupsList adgroupsGet($accountId, $filtering, $page, $pageSize, $isDeleted, $fields)

获取广告组

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\AdgroupFilteringStruct()); // \TencentAds\Model\AdgroupFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$isDeleted = true; // bool | 是否已删除
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->adgroups()->get($accountId, $filtering, $page, $pageSize, $isDeleted, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling adgroups()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **filtering** | [**\TencentAds\Model\AdgroupFilteringStruct[]**](../Model/\TencentAds\Model\AdgroupFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **isDeleted** | **bool**| 是否已删除 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\AdgroupsList**](../Model/AdgroupsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **adgroupsUpdate**
> \TencentAds\Model\AdgroupsUpdateResponse adgroupsUpdate($data)

更新广告组

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AdgroupsUpdateRequest(); // \TencentAds\Model\AdgroupsUpdateRequest | 

try {
    $result = $tads->adgroups()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling adgroups()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AdgroupsUpdateRequest**](../Model/AdgroupsUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\AdgroupsUpdateResponse**](../Model/AdgroupsUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

