# TencentAds\AdsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**adsAdd**](AdsApi.md#adsAdd) | **POST** /ads/add | 创建广告
[**adsDelete**](AdsApi.md#adsDelete) | **POST** /ads/delete | 删除广告
[**adsGet**](AdsApi.md#adsGet) | **GET** /ads/get | 获取广告
[**adsUpdate**](AdsApi.md#adsUpdate) | **POST** /ads/update | 更新广告


# **adsAdd**
> \TencentAds\Model\AdsAddResponse adsAdd($data)

创建广告

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AdsAddRequest(); // \TencentAds\Model\AdsAddRequest | 

try {
    $result = $tads->ads()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ads()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AdsAddRequest**](../Model/AdsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\AdsAddResponse**](../Model/AdsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **adsDelete**
> \TencentAds\Model\AdsDeleteResponse adsDelete($data)

删除广告

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AdsDeleteRequest(); // \TencentAds\Model\AdsDeleteRequest | 

try {
    $result = $tads->ads()->delete($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ads()->delete(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AdsDeleteRequest**](../Model/AdsDeleteRequest.md)|  |

### Return type

[**\TencentAds\Model\AdsDeleteResponse**](../Model/AdsDeleteResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **adsGet**
> \TencentAds\Model\AdsList adsGet($accountId, $filtering, $page, $pageSize, $isDeleted, $fields)

获取广告

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\AdFilteringStruct()); // \TencentAds\Model\AdFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$isDeleted = true; // bool | 是否已删除
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->ads()->get($accountId, $filtering, $page, $pageSize, $isDeleted, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ads()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **filtering** | [**\TencentAds\Model\AdFilteringStruct[]**](../Model/\TencentAds\Model\AdFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **isDeleted** | **bool**| 是否已删除 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\AdsList**](../Model/AdsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **adsUpdate**
> \TencentAds\Model\AdsUpdateResponse adsUpdate($data)

更新广告

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AdsUpdateRequest(); // \TencentAds\Model\AdsUpdateRequest | 

try {
    $result = $tads->ads()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ads()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AdsUpdateRequest**](../Model/AdsUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\AdsUpdateResponse**](../Model/AdsUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

