# TencentAds\AdvertiserApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**advertiserAdd**](AdvertiserApi.md#advertiserAdd) | **POST** /advertiser/add | 添加服务商子客户
[**advertiserGet**](AdvertiserApi.md#advertiserGet) | **GET** /advertiser/get | 获取广告主信息
[**advertiserUpdate**](AdvertiserApi.md#advertiserUpdate) | **POST** /advertiser/update | 更新广告主信息


# **advertiserAdd**
> \TencentAds\Model\AdvertiserAddResponse advertiserAdd($data)

添加服务商子客户

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AdvertiserAddRequest(); // \TencentAds\Model\AdvertiserAddRequest | 

try {
    $result = $tads->advertiser()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling advertiser()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AdvertiserAddRequest**](../Model/AdvertiserAddRequest.md)|  |

### Return type

[**\TencentAds\Model\AdvertiserAddResponse**](../Model/AdvertiserAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **advertiserGet**
> \TencentAds\Model\AdvertiserList advertiserGet($accountId, $filtering, $page, $pageSize, $fields)

获取广告主信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\AgencyFilteringStruct()); // \TencentAds\Model\AgencyFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->advertiser()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling advertiser()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id | [optional]
 **filtering** | [**\TencentAds\Model\AgencyFilteringStruct[]**](../Model/\TencentAds\Model\AgencyFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\AdvertiserList**](../Model/AdvertiserList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **advertiserUpdate**
> \TencentAds\Model\AdvertiserUpdateResponse advertiserUpdate($data)

更新广告主信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AdvertiserUpdateRequest(); // \TencentAds\Model\AdvertiserUpdateRequest | 

try {
    $result = $tads->advertiser()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling advertiser()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AdvertiserUpdateRequest**](../Model/AdvertiserUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\AdvertiserUpdateResponse**](../Model/AdvertiserUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

