# TencentAds\AndroidChannelPackagesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**androidChannelPackagesGet**](AndroidChannelPackagesApi.md#androidChannelPackagesGet) | **GET** /android_channel_packages/get | 获取安卓渠道包


# **androidChannelPackagesGet**
> \TencentAds\Model\AndroidChannelPackagesList androidChannelPackagesGet($accountId, $myappAuthKey, $androidAppId, $page, $pageSize, $fields)

获取安卓渠道包

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$myappAuthKey = "myappAuthKey_example"; // string | api授权id，在应用宝账号下分配。
$androidAppId = 789; // int | 应用宝APP ID
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->androidChannelPackages()->get($accountId, $myappAuthKey, $androidAppId, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling androidChannelPackages()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **myappAuthKey** | **string**| api授权id，在应用宝账号下分配。 |
 **androidAppId** | **int**| 应用宝APP ID |
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\AndroidChannelPackagesList**](../Model/AndroidChannelPackagesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

