# TencentAds\AssetPermissionsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**assetPermissionsAdd**](AssetPermissionsApi.md#assetPermissionsAdd) | **POST** /asset_permissions/add | 资产权限授予
[**assetPermissionsDelete**](AssetPermissionsApi.md#assetPermissionsDelete) | **POST** /asset_permissions/delete | 资产权限回收


# **assetPermissionsAdd**
> \TencentAds\Model\AssetPermissionsAddResponse assetPermissionsAdd($data)

资产权限授予

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AssetPermissionsAddRequest(); // \TencentAds\Model\AssetPermissionsAddRequest | 

try {
    $result = $tads->assetPermissions()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling assetPermissions()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AssetPermissionsAddRequest**](../Model/AssetPermissionsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\AssetPermissionsAddResponse**](../Model/AssetPermissionsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **assetPermissionsDelete**
> \TencentAds\Model\AssetPermissionsDeleteResponse assetPermissionsDelete($data)

资产权限回收

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AssetPermissionsDeleteRequest(); // \TencentAds\Model\AssetPermissionsDeleteRequest | 

try {
    $result = $tads->assetPermissions()->delete($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling assetPermissions()->delete(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AssetPermissionsDeleteRequest**](../Model/AssetPermissionsDeleteRequest.md)|  |

### Return type

[**\TencentAds\Model\AssetPermissionsDeleteResponse**](../Model/AssetPermissionsDeleteResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

