# TencentAds\AsyncTaskFilesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**asyncTaskFilesGet**](AsyncTaskFilesApi.md#asyncTaskFilesGet) | **GET** /async_task_files/get | 获取文件接口


# **asyncTaskFilesGet**
> string asyncTaskFilesGet($accountId, $taskId, $fileId, $fields)

获取文件接口

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$taskId = 789; // int | 任务 id
$fileId = 789; // int | 文件 id
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->asyncTaskFiles()->get($accountId, $taskId, $fileId, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling asyncTaskFiles()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **taskId** | **int**| 任务 id |
 **fileId** | **int**| 文件 id |
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

**string**

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

