# TencentAds\AudienceGrantRelationsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**audienceGrantRelationsAdd**](AudienceGrantRelationsApi.md#audienceGrantRelationsAdd) | **POST** /audience_grant_relations/add | 添加人群授权
[**audienceGrantRelationsGet**](AudienceGrantRelationsApi.md#audienceGrantRelationsGet) | **GET** /audience_grant_relations/get | 获取人群授权信息


# **audienceGrantRelationsAdd**
> \TencentAds\Model\AudienceGrantRelationsAddResponse audienceGrantRelationsAdd($data)

添加人群授权

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\AudienceGrantRelationsAddRequest(); // \TencentAds\Model\AudienceGrantRelationsAddRequest | 

try {
    $result = $tads->audienceGrantRelations()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling audienceGrantRelations()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\AudienceGrantRelationsAddRequest**](../Model/AudienceGrantRelationsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\AudienceGrantRelationsAddResponse**](../Model/AudienceGrantRelationsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **audienceGrantRelationsGet**
> \TencentAds\Model\AudienceGrantRelationsList audienceGrantRelationsGet($accountId, $filtering, $page, $pageSize, $fields)

获取人群授权信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\AudienceGrantRelationsGetSingleFilter()); // \TencentAds\Model\AudienceGrantRelationsGetSingleFilter[] | 过滤条件，若此字段不传，或传空则视为无限制条件，详见 <a href='/docs/reference/illustration#filtering' target='_blank'>[过滤条件]</a>
$page = 789; // int | 当前页码
$pageSize = 789; // int | 分页大小
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->audienceGrantRelations()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling audienceGrantRelations()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **filtering** | [**\TencentAds\Model\AudienceGrantRelationsGetSingleFilter[]**](../Model/\TencentAds\Model\AudienceGrantRelationsGetSingleFilter.md)| 过滤条件，若此字段不传，或传空则视为无限制条件，详见 &lt;a href&#x3D;&#39;/docs/reference/illustration#filtering&#39; target&#x3D;&#39;_blank&#39;&gt;[过滤条件]&lt;/a&gt; | [optional]
 **page** | **int**| 当前页码 | [optional]
 **pageSize** | **int**| 分页大小 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\AudienceGrantRelationsList**](../Model/AudienceGrantRelationsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

