# TencentAds\AuthorizationApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**authorizationWechatBind**](AuthorizationApi.md#authorizationWechatBind) | **GET** /authorization/wechat_bind | 绑定微信公众号


# **authorizationWechatBind**
> string authorizationWechatBind($accessToken, $redirectUri, $accountId, $wechatAccountId)

绑定微信公众号

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accessToken = "accessToken_example"; // string | 应用 access token，获取方式详见 <a href='/docs/start/authorization' target='_blank'>[授权认证]</a> 章节
$redirectUri = "redirectUri_example"; // string | 应用回调地址
$accountId = 789; // int | 绑定广告主ID
$wechatAccountId = "wechatAccountId_example"; // string | 微信公众号id

try {
    $result = $tads->authorization()->wechatbind($accessToken, $redirectUri, $accountId, $wechatAccountId);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling authorization()->wechatbind(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accessToken** | **string**| 应用 access token，获取方式详见 &lt;a href&#x3D;&#39;/docs/start/authorization&#39; target&#x3D;&#39;_blank&#39;&gt;[授权认证]&lt;/a&gt; 章节 |
 **redirectUri** | **string**| 应用回调地址 |
 **accountId** | **int**| 绑定广告主ID | [optional]
 **wechatAccountId** | **string**| 微信公众号id | [optional]

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

