# TencentAds\BatchOperationApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**batchOperationAdd**](BatchOperationApi.md#batchOperationAdd) | **POST** /batch_operation/add | 创建批量操作


# **batchOperationAdd**
> \TencentAds\Model\BatchOperationAddResponse batchOperationAdd($data)

创建批量操作

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\BatchOperationAddRequest(); // \TencentAds\Model\BatchOperationAddRequest | 

try {
    $result = $tads->batchOperation()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling batchOperation()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\BatchOperationAddRequest**](../Model/BatchOperationAddRequest.md)|  |

### Return type

[**\TencentAds\Model\BatchOperationAddResponse**](../Model/BatchOperationAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

