# TencentAds\CampaignsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**campaignsAdd**](CampaignsApi.md#campaignsAdd) | **POST** /campaigns/add | 创建推广计划
[**campaignsDelete**](CampaignsApi.md#campaignsDelete) | **POST** /campaigns/delete | 删除推广计划
[**campaignsGet**](CampaignsApi.md#campaignsGet) | **GET** /campaigns/get | 获取推广计划
[**campaignsUpdate**](CampaignsApi.md#campaignsUpdate) | **POST** /campaigns/update | 更新推广计划


# **campaignsAdd**
> \TencentAds\Model\CampaignsAddResponse campaignsAdd($data)

创建推广计划

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CampaignsAddRequest(); // \TencentAds\Model\CampaignsAddRequest | 

try {
    $result = $tads->campaigns()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling campaigns()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CampaignsAddRequest**](../Model/CampaignsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\CampaignsAddResponse**](../Model/CampaignsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **campaignsDelete**
> \TencentAds\Model\CampaignsDeleteResponse campaignsDelete($data)

删除推广计划

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CampaignsDeleteRequest(); // \TencentAds\Model\CampaignsDeleteRequest | 

try {
    $result = $tads->campaigns()->delete($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling campaigns()->delete(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CampaignsDeleteRequest**](../Model/CampaignsDeleteRequest.md)|  |

### Return type

[**\TencentAds\Model\CampaignsDeleteResponse**](../Model/CampaignsDeleteResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **campaignsGet**
> \TencentAds\Model\CampaignsList campaignsGet($accountId, $filtering, $page, $pageSize, $isDeleted, $fields)

获取推广计划

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商 id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\CampaignsFilteringStruct()); // \TencentAds\Model\CampaignsFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$isDeleted = true; // bool | 是否已删除
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->campaigns()->get($accountId, $filtering, $page, $pageSize, $isDeleted, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling campaigns()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商 id |
 **filtering** | [**\TencentAds\Model\CampaignsFilteringStruct[]**](../Model/\TencentAds\Model\CampaignsFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **isDeleted** | **bool**| 是否已删除 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\CampaignsList**](../Model/CampaignsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **campaignsUpdate**
> \TencentAds\Model\CampaignsUpdateResponse campaignsUpdate($data)

更新推广计划

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CampaignsUpdateRequest(); // \TencentAds\Model\CampaignsUpdateRequest | 

try {
    $result = $tads->campaigns()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling campaigns()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CampaignsUpdateRequest**](../Model/CampaignsUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\CampaignsUpdateResponse**](../Model/CampaignsUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

