# TencentAds\CapabilitiesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**capabilitiesGet**](CapabilitiesApi.md#capabilitiesGet) | **GET** /capabilities/get | 查询广告相关权限


# **capabilitiesGet**
> \TencentAds\Model\CapabilitiesList capabilitiesGet($accountId, $capability, $querySpec, $fields)

查询广告相关权限

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$capability = "capability_example"; // string | 广告投放能力
$querySpec = array('key' => "querySpec_example"); // map[string,string] | 查询条件
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->capabilities()->get($accountId, $capability, $querySpec, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling capabilities()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **capability** | **string**| 广告投放能力 |
 **querySpec** | [**map[string,string]**](../Model/string.md)| 查询条件 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\CapabilitiesList**](../Model/CapabilitiesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

