# TencentAds\CustomAudienceFilesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**customAudienceFilesAdd**](CustomAudienceFilesApi.md#customAudienceFilesAdd) | **POST** /custom_audience_files/add | 上传客户人群数据文件
[**customAudienceFilesGet**](CustomAudienceFilesApi.md#customAudienceFilesGet) | **GET** /custom_audience_files/get | 获取客户人群数据文件


# **customAudienceFilesAdd**
> \TencentAds\Model\CustomAudienceFilesAddResponse customAudienceFilesAdd($accountId, $audienceId, $userIdType, $file, $operationType, $saltId)

上传客户人群数据文件

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id
$audienceId = 789; // int | 人群 id，通过 <a href='/docs/api/audiences/custom_audience/custom_audiences_add' target='_blank'>[custom_audiences]</a> 模块创建客户人群获得
$userIdType = "userIdType_example"; // string | 号码包用户ID类型
$file = "/path/to/file.txt"; // \SplFileObject | 上传人群文件
$operationType = "operationType_example"; // string | 文件操作类型
$saltId = "saltId_example"; // string | 数据加密的盐 id，当且仅当数据文件中的用户 id 类型为 'SALTED_HASH_IMEI' 或 'SALTED_HASH_IDFA' 时有效

try {
    $result = $tads->customAudienceFiles()->add($accountId, $audienceId, $userIdType, $file, $operationType, $saltId);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customAudienceFiles()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **audienceId** | **int**| 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得 |
 **userIdType** | **string**| 号码包用户ID类型 |
 **file** | **\SplFileObject**| 上传人群文件 |
 **operationType** | **string**| 文件操作类型 | [optional]
 **saltId** | **string**| 数据加密的盐 id，当且仅当数据文件中的用户 id 类型为 &#39;SALTED_HASH_IMEI&#39; 或 &#39;SALTED_HASH_IDFA&#39; 时有效 | [optional]

### Return type

[**\TencentAds\Model\CustomAudienceFilesAddResponse**](../Model/CustomAudienceFilesAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customAudienceFilesGet**
> \TencentAds\Model\CustomAudienceFilesList customAudienceFilesGet($accountId, $audienceId, $customAudienceFileId, $page, $pageSize, $fields)

获取客户人群数据文件

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id
$audienceId = 789; // int | 人群 id，通过 <a href='/docs/api/audiences/custom_audience/custom_audiences_add' target='_blank'>[custom_audiences]</a> 模块创建客户人群获得
$customAudienceFileId = 789; // int | 数据文件 id，通过 <a href='/docs/api/audiences/custom_audience_file/custom_audience_files_add' target='_blank'>[custom_audience_files]</a> 模块上传客户人群数据文件获得
$page = 789; // int | 当前页码
$pageSize = 789; // int | 分页大小
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->customAudienceFiles()->get($accountId, $audienceId, $customAudienceFileId, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customAudienceFiles()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **audienceId** | **int**| 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得 | [optional]
 **customAudienceFileId** | **int**| 数据文件 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience_file/custom_audience_files_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audience_files]&lt;/a&gt; 模块上传客户人群数据文件获得 | [optional]
 **page** | **int**| 当前页码 | [optional]
 **pageSize** | **int**| 分页大小 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\CustomAudienceFilesList**](../Model/CustomAudienceFilesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

