# TencentAds\CustomAudienceInsightsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**customAudienceInsightsGet**](CustomAudienceInsightsApi.md#customAudienceInsightsGet) | **GET** /custom_audience_insights/get | 人群洞察分析


# **customAudienceInsightsGet**
> \TencentAds\Model\CustomAudienceInsightsList customAudienceInsightsGet($accountId, $audienceId, $dimensionType, $fields)

人群洞察分析

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id
$audienceId = 789; // int | 人群 id，通过 <a href='/docs/api/audiences/custom_audience/custom_audiences_add' target='_blank'>[custom_audiences]</a> 模块创建客户人群获得,仅支持LBS、KEYWORD、AD、USER_ACTION类型的人群透视
$dimensionType = array(new \TencentAds\Model\\TencentAds\Model\CustomAudienceInsightsDimensionType()); // \TencentAds\Model\CustomAudienceInsightsDimensionType[] | 透视维度数组
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->customAudienceInsights()->get($accountId, $audienceId, $dimensionType, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customAudienceInsights()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **audienceId** | **int**| 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得,仅支持LBS、KEYWORD、AD、USER_ACTION类型的人群透视 |
 **dimensionType** | [**\TencentAds\Model\CustomAudienceInsightsDimensionType[]**](../Model/\TencentAds\Model\CustomAudienceInsightsDimensionType.md)| 透视维度数组 |
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\CustomAudienceInsightsList**](../Model/CustomAudienceInsightsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

