# TencentAds\CustomAudienceReportsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**customAudienceReportsGet**](CustomAudienceReportsApi.md#customAudienceReportsGet) | **GET** /custom_audience_reports/get | 人群报表


# **customAudienceReportsGet**
> \TencentAds\Model\CustomAudienceReportsList customAudienceReportsGet($accountId, $filtering, $dateRange, $groupBy, $fields)

人群报表

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 指定查询的广告主id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\CustomAudienceReportsFilteringStruct()); // \TencentAds\Model\CustomAudienceReportsFilteringStruct[] | 过滤条件，详见 <a href='/docs/reference/illustration#filtering' target='_blank'>[过滤条件]</a>
$dateRange = array('key' => "dateRange_example"); // map[string,string] | 时间范围
$groupBy = array("groupBy_example"); // string[] | 聚合参数，可选值{ account_id,audience_id,adgroup_id,wechat_adgroup_id,campaign_id,wechat_campaign_id,action_type,model_id,audience_predict_task_id }
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->customAudienceReports()->get($accountId, $filtering, $dateRange, $groupBy, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customAudienceReports()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 指定查询的广告主id |
 **filtering** | [**\TencentAds\Model\CustomAudienceReportsFilteringStruct[]**](../Model/\TencentAds\Model\CustomAudienceReportsFilteringStruct.md)| 过滤条件，详见 &lt;a href&#x3D;&#39;/docs/reference/illustration#filtering&#39; target&#x3D;&#39;_blank&#39;&gt;[过滤条件]&lt;/a&gt; |
 **dateRange** | [**map[string,string]**](../Model/string.md)| 时间范围 |
 **groupBy** | [**string[]**](../Model/string.md)| 聚合参数，可选值{ account_id,audience_id,adgroup_id,wechat_adgroup_id,campaign_id,wechat_campaign_id,action_type,model_id,audience_predict_task_id } | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\CustomAudienceReportsList**](../Model/CustomAudienceReportsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

