# TencentAds\CustomAudiencesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**customAudiencesAdd**](CustomAudiencesApi.md#customAudiencesAdd) | **POST** /custom_audiences/add | 创建客户人群
[**customAudiencesDelete**](CustomAudiencesApi.md#customAudiencesDelete) | **POST** /custom_audiences/delete | 删除客户人群
[**customAudiencesGet**](CustomAudiencesApi.md#customAudiencesGet) | **GET** /custom_audiences/get | 获取客户人群
[**customAudiencesUpdate**](CustomAudiencesApi.md#customAudiencesUpdate) | **POST** /custom_audiences/update | 更新客户人群


# **customAudiencesAdd**
> \TencentAds\Model\CustomAudiencesAddResponse customAudiencesAdd($data)

创建客户人群

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomAudiencesAddRequest(); // \TencentAds\Model\CustomAudiencesAddRequest | 

try {
    $result = $tads->customAudiences()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customAudiences()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomAudiencesAddRequest**](../Model/CustomAudiencesAddRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomAudiencesAddResponse**](../Model/CustomAudiencesAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customAudiencesDelete**
> \TencentAds\Model\CustomAudiencesDeleteResponse customAudiencesDelete($data)

删除客户人群

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomAudiencesDeleteRequest(); // \TencentAds\Model\CustomAudiencesDeleteRequest | 

try {
    $result = $tads->customAudiences()->delete($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customAudiences()->delete(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomAudiencesDeleteRequest**](../Model/CustomAudiencesDeleteRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomAudiencesDeleteResponse**](../Model/CustomAudiencesDeleteResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customAudiencesGet**
> \TencentAds\Model\CustomAudiencesList customAudiencesGet($accountId, $audienceId, $page, $pageSize, $platform, $fields)

获取客户人群

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id
$audienceId = 789; // int | 人群 id，通过 <a href='/docs/api/audiences/custom_audience/custom_audiences_add' target='_blank'>[custom_audiences]</a> 模块创建客户人群获得
$page = 789; // int | 当前页码
$pageSize = 789; // int | 分页大小
$platform = "platform_example"; // string | 数据应用
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->customAudiences()->get($accountId, $audienceId, $page, $pageSize, $platform, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customAudiences()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **audienceId** | **int**| 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得 | [optional]
 **page** | **int**| 当前页码 | [optional]
 **pageSize** | **int**| 分页大小 | [optional]
 **platform** | **string**| 数据应用 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\CustomAudiencesList**](../Model/CustomAudiencesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customAudiencesUpdate**
> \TencentAds\Model\CustomAudiencesUpdateResponse customAudiencesUpdate($data)

更新客户人群

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomAudiencesUpdateRequest(); // \TencentAds\Model\CustomAudiencesUpdateRequest | 

try {
    $result = $tads->customAudiences()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customAudiences()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomAudiencesUpdateRequest**](../Model/CustomAudiencesUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomAudiencesUpdateResponse**](../Model/CustomAudiencesUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

