# TencentAds\CustomFeatureClassProjectGrantsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**customFeatureClassProjectGrantsAdd**](CustomFeatureClassProjectGrantsApi.md#customFeatureClassProjectGrantsAdd) | **POST** /custom_feature_class_project_grants/add | 添加自定义特征类授权
[**customFeatureClassProjectGrantsGet**](CustomFeatureClassProjectGrantsApi.md#customFeatureClassProjectGrantsGet) | **POST** /custom_feature_class_project_grants/get | 获取自定义特征类授权


# **customFeatureClassProjectGrantsAdd**
> \TencentAds\Model\CustomFeatureClassProjectGrantsAddResponse customFeatureClassProjectGrantsAdd($data)

添加自定义特征类授权

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomFeatureClassProjectGrantsAddRequest(); // \TencentAds\Model\CustomFeatureClassProjectGrantsAddRequest | 

try {
    $result = $tads->customFeatureClassProjectGrants()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customFeatureClassProjectGrants()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomFeatureClassProjectGrantsAddRequest**](../Model/CustomFeatureClassProjectGrantsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomFeatureClassProjectGrantsAddResponse**](../Model/CustomFeatureClassProjectGrantsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customFeatureClassProjectGrantsGet**
> \TencentAds\Model\CustomFeatureClassProjectGrantsList customFeatureClassProjectGrantsGet($data)

获取自定义特征类授权

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomFeatureClassProjectGrantsGetRequest(); // \TencentAds\Model\CustomFeatureClassProjectGrantsGetRequest | 

try {
    $result = $tads->customFeatureClassProjectGrants()->get($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customFeatureClassProjectGrants()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomFeatureClassProjectGrantsGetRequest**](../Model/CustomFeatureClassProjectGrantsGetRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomFeatureClassProjectGrantsList**](../Model/CustomFeatureClassProjectGrantsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

