# TencentAds\CustomFeatureClassesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**customFeatureClassesAdd**](CustomFeatureClassesApi.md#customFeatureClassesAdd) | **POST** /custom_feature_classes/add | 添加自定义特征类
[**customFeatureClassesGet**](CustomFeatureClassesApi.md#customFeatureClassesGet) | **POST** /custom_feature_classes/get | 获取自定义特征类
[**customFeatureClassesUpdate**](CustomFeatureClassesApi.md#customFeatureClassesUpdate) | **POST** /custom_feature_classes/update | 更新自定义特征类


# **customFeatureClassesAdd**
> \TencentAds\Model\CustomFeatureClassesAddResponse customFeatureClassesAdd($data)

添加自定义特征类

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomFeatureClassesAddRequest(); // \TencentAds\Model\CustomFeatureClassesAddRequest | 

try {
    $result = $tads->customFeatureClasses()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customFeatureClasses()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomFeatureClassesAddRequest**](../Model/CustomFeatureClassesAddRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomFeatureClassesAddResponse**](../Model/CustomFeatureClassesAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customFeatureClassesGet**
> \TencentAds\Model\CustomFeatureClassesList customFeatureClassesGet($data)

获取自定义特征类

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomFeatureClassesGetRequest(); // \TencentAds\Model\CustomFeatureClassesGetRequest | 

try {
    $result = $tads->customFeatureClasses()->get($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customFeatureClasses()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomFeatureClassesGetRequest**](../Model/CustomFeatureClassesGetRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomFeatureClassesList**](../Model/CustomFeatureClassesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customFeatureClassesUpdate**
> \TencentAds\Model\CustomFeatureClassesUpdateResponse customFeatureClassesUpdate($data)

更新自定义特征类

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomFeatureClassesUpdateRequest(); // \TencentAds\Model\CustomFeatureClassesUpdateRequest | 

try {
    $result = $tads->customFeatureClasses()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customFeatureClasses()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomFeatureClassesUpdateRequest**](../Model/CustomFeatureClassesUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomFeatureClassesUpdateResponse**](../Model/CustomFeatureClassesUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

