# TencentAds\CustomFeaturesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**customFeaturesAdd**](CustomFeaturesApi.md#customFeaturesAdd) | **POST** /custom_features/add | 添加自定义特征
[**customFeaturesDelete**](CustomFeaturesApi.md#customFeaturesDelete) | **POST** /custom_features/delete | 删除自定义特征
[**customFeaturesGet**](CustomFeaturesApi.md#customFeaturesGet) | **GET** /custom_features/get | 获取自定义特征
[**customFeaturesUpdate**](CustomFeaturesApi.md#customFeaturesUpdate) | **POST** /custom_features/update | 更新自定义特征


# **customFeaturesAdd**
> \TencentAds\Model\CustomFeaturesAddResponse customFeaturesAdd($data)

添加自定义特征

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomFeaturesAddRequest(); // \TencentAds\Model\CustomFeaturesAddRequest | 

try {
    $result = $tads->customFeatures()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customFeatures()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomFeaturesAddRequest**](../Model/CustomFeaturesAddRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomFeaturesAddResponse**](../Model/CustomFeaturesAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customFeaturesDelete**
> \TencentAds\Model\CustomFeaturesDeleteResponse customFeaturesDelete($data)

删除自定义特征

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomFeaturesDeleteRequest(); // \TencentAds\Model\CustomFeaturesDeleteRequest | 

try {
    $result = $tads->customFeatures()->delete($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customFeatures()->delete(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomFeaturesDeleteRequest**](../Model/CustomFeaturesDeleteRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomFeaturesDeleteResponse**](../Model/CustomFeaturesDeleteResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customFeaturesGet**
> \TencentAds\Model\CustomFeaturesList customFeaturesGet($accountId, $filtering, $page, $pageSize, $fields)

获取自定义特征

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 帐号ID，包含品牌数据智库ID和生态数据智库ID
$filtering = array(new \TencentAds\Model\\TencentAds\Model\CustomFeaturesGetSingleFilter()); // \TencentAds\Model\CustomFeaturesGetSingleFilter[] | 过滤条件，若此字段不传，或传空则视为无限制条件，详见 <a href='/docs/reference/illustration#filtering' target='_blank'>[过滤条件]</a>
$page = 789; // int | 当前页码
$pageSize = 789; // int | 分页大小
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->customFeatures()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customFeatures()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 帐号ID，包含品牌数据智库ID和生态数据智库ID |
 **filtering** | [**\TencentAds\Model\CustomFeaturesGetSingleFilter[]**](../Model/\TencentAds\Model\CustomFeaturesGetSingleFilter.md)| 过滤条件，若此字段不传，或传空则视为无限制条件，详见 &lt;a href&#x3D;&#39;/docs/reference/illustration#filtering&#39; target&#x3D;&#39;_blank&#39;&gt;[过滤条件]&lt;/a&gt; | [optional]
 **page** | **int**| 当前页码 | [optional]
 **pageSize** | **int**| 分页大小 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\CustomFeaturesList**](../Model/CustomFeaturesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customFeaturesUpdate**
> \TencentAds\Model\CustomFeaturesUpdateResponse customFeaturesUpdate($data)

更新自定义特征

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomFeaturesUpdateRequest(); // \TencentAds\Model\CustomFeaturesUpdateRequest | 

try {
    $result = $tads->customFeatures()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customFeatures()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomFeaturesUpdateRequest**](../Model/CustomFeaturesUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomFeaturesUpdateResponse**](../Model/CustomFeaturesUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

