# TencentAds\CustomTagFilesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**customTagFilesAdd**](CustomTagFilesApi.md#customTagFilesAdd) | **POST** /custom_tag_files/add | 上传客户标签人群数据文件
[**customTagFilesGet**](CustomTagFilesApi.md#customTagFilesGet) | **GET** /custom_tag_files/get | 获取客户标签人群文件


# **customTagFilesAdd**
> \TencentAds\Model\CustomTagFilesAddResponse customTagFilesAdd($accountId, $userIdType, $tagId, $file, $operationType, $openAppId)

上传客户标签人群数据文件

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id
$userIdType = "userIdType_example"; // string | 号码包用户ID类型
$tagId = 789; // int | 标签Id
$file = "/path/to/file.txt"; // \SplFileObject | 上传标签人群文件
$operationType = "operationType_example"; // string | 文件操作类型
$openAppId = "openAppId_example"; // string | 微信/QQ手机版 appid，当且仅当数据文件中的用户 id 类型为 'WECHAT_OPENID' （WX_OPENID）或 'MOBILE_QQ_OPENID' 时有效

try {
    $result = $tads->customTagFiles()->add($accountId, $userIdType, $tagId, $file, $operationType, $openAppId);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customTagFiles()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **userIdType** | **string**| 号码包用户ID类型 |
 **tagId** | **int**| 标签Id |
 **file** | **\SplFileObject**| 上传标签人群文件 |
 **operationType** | **string**| 文件操作类型 | [optional]
 **openAppId** | **string**| 微信/QQ手机版 appid，当且仅当数据文件中的用户 id 类型为 &#39;WECHAT_OPENID&#39; （WX_OPENID）或 &#39;MOBILE_QQ_OPENID&#39; 时有效 | [optional]

### Return type

[**\TencentAds\Model\CustomTagFilesAddResponse**](../Model/CustomTagFilesAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customTagFilesGet**
> \TencentAds\Model\CustomTagFilesList customTagFilesGet($accountId, $filtering, $page, $pageSize, $fields)

获取客户标签人群文件

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\CustomTagFilesGetSingleFilter()); // \TencentAds\Model\CustomTagFilesGetSingleFilter[] | 过滤条件，若此字段不传，或传空则视为无限制条件，详见 <a href='/docs/reference/illustration#filtering' target='_blank'>[过滤条件]</a>
$page = 789; // int | 当前页码
$pageSize = 789; // int | 分页大小
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->customTagFiles()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customTagFiles()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **filtering** | [**\TencentAds\Model\CustomTagFilesGetSingleFilter[]**](../Model/\TencentAds\Model\CustomTagFilesGetSingleFilter.md)| 过滤条件，若此字段不传，或传空则视为无限制条件，详见 &lt;a href&#x3D;&#39;/docs/reference/illustration#filtering&#39; target&#x3D;&#39;_blank&#39;&gt;[过滤条件]&lt;/a&gt; | [optional]
 **page** | **int**| 当前页码 | [optional]
 **pageSize** | **int**| 分页大小 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\CustomTagFilesList**](../Model/CustomTagFilesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

