# TencentAds\CustomTagsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**customTagsAdd**](CustomTagsApi.md#customTagsAdd) | **POST** /custom_tags/add | 创建客户标签
[**customTagsDelete**](CustomTagsApi.md#customTagsDelete) | **POST** /custom_tags/delete | 删除客户标签
[**customTagsGet**](CustomTagsApi.md#customTagsGet) | **GET** /custom_tags/get | 获取客户标签
[**customTagsUpdate**](CustomTagsApi.md#customTagsUpdate) | **POST** /custom_tags/update | 更新客户标签


# **customTagsAdd**
> \TencentAds\Model\CustomTagsAddResponse customTagsAdd($data)

创建客户标签

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomTagsAddRequest(); // \TencentAds\Model\CustomTagsAddRequest | 

try {
    $result = $tads->customTags()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customTags()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomTagsAddRequest**](../Model/CustomTagsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomTagsAddResponse**](../Model/CustomTagsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customTagsDelete**
> \TencentAds\Model\CustomTagsDeleteResponse customTagsDelete($data)

删除客户标签

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomTagsDeleteRequest(); // \TencentAds\Model\CustomTagsDeleteRequest | 

try {
    $result = $tads->customTags()->delete($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customTags()->delete(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomTagsDeleteRequest**](../Model/CustomTagsDeleteRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomTagsDeleteResponse**](../Model/CustomTagsDeleteResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customTagsGet**
> \TencentAds\Model\CustomTagsList customTagsGet($accountId, $parentTagId, $tagId, $tagCode, $platform, $page, $pageSize, $fields)

获取客户标签

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id
$parentTagId = 789; // int | 父节点Id
$tagId = 789; // int | 标签id
$tagCode = "tagCode_example"; // string | 广告主对标签在自己系统里的编码
$platform = "platform_example"; // string | 数据应用
$page = 789; // int | 当前页码
$pageSize = 789; // int | 分页大小
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->customTags()->get($accountId, $parentTagId, $tagId, $tagCode, $platform, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customTags()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **parentTagId** | **int**| 父节点Id | [optional]
 **tagId** | **int**| 标签id | [optional]
 **tagCode** | **string**| 广告主对标签在自己系统里的编码 | [optional]
 **platform** | **string**| 数据应用 | [optional]
 **page** | **int**| 当前页码 | [optional]
 **pageSize** | **int**| 分页大小 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\CustomTagsList**](../Model/CustomTagsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customTagsUpdate**
> \TencentAds\Model\CustomTagsUpdateResponse customTagsUpdate($data)

更新客户标签

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\CustomTagsUpdateRequest(); // \TencentAds\Model\CustomTagsUpdateRequest | 

try {
    $result = $tads->customTags()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling customTags()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\CustomTagsUpdateRequest**](../Model/CustomTagsUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\CustomTagsUpdateResponse**](../Model/CustomTagsUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

