# TencentAds\DailyCostApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**dailyCostGet**](DailyCostApi.md#dailyCostGet) | **GET** /daily_cost/get | 获取微信账户实时消耗


# **dailyCostGet**
> \TencentAds\Model\DailyCostList dailyCostGet($dateRange, $accountId, $filtering, $page, $pageSize, $fields)

获取微信账户实时消耗

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$dateRange = array('key' => "dateRange_example"); // map[string,string] | 日期范围
$accountId = 789; // int | 推广帐号 id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\GetDailyCostFilteringStruct()); // \TencentAds\Model\GetDailyCostFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->dailyCost()->get($dateRange, $accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling dailyCost()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dateRange** | [**map[string,string]**](../Model/string.md)| 日期范围 |
 **accountId** | **int**| 推广帐号 id | [optional]
 **filtering** | [**\TencentAds\Model\GetDailyCostFilteringStruct[]**](../Model/\TencentAds\Model\GetDailyCostFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\DailyCostList**](../Model/DailyCostList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

