# TencentAds\DailyReportsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**dailyReportsGet**](DailyReportsApi.md#dailyReportsGet) | **GET** /daily_reports/get | 获取日报表


# **dailyReportsGet**
> \TencentAds\Model\DailyReportsList dailyReportsGet($accountId, $level, $dateRange, $filtering, $groupBy, $orderBy, $page, $pageSize, $timeLine, $fields)

获取日报表

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$level = "level_example"; // string | 获取报表类型级别
$dateRange = array('key' => "dateRange_example"); // map[string,string] | 日期范围
$filtering = array(new \TencentAds\Model\\TencentAds\Model\DailyReportsGetFilteringStruct()); // \TencentAds\Model\DailyReportsGetFilteringStruct[] | 过滤条件
$groupBy = array("groupBy_example"); // string[] | 聚合参数
$orderBy = array(new \TencentAds\Model\\TencentAds\Model\ReportOrderByStruct()); // \TencentAds\Model\ReportOrderByStruct[] | 排序字段
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$timeLine = "timeLine_example"; // string | 时间口径
$fields = array("fields_example"); // string[] | 指定返回的字段列表

try {
    $result = $tads->dailyReports()->get($accountId, $level, $dateRange, $filtering, $groupBy, $orderBy, $page, $pageSize, $timeLine, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling dailyReports()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **level** | **string**| 获取报表类型级别 |
 **dateRange** | [**map[string,string]**](../Model/string.md)| 日期范围 |
 **filtering** | [**\TencentAds\Model\DailyReportsGetFilteringStruct[]**](../Model/\TencentAds\Model\DailyReportsGetFilteringStruct.md)| 过滤条件 | [optional]
 **groupBy** | [**string[]**](../Model/string.md)| 聚合参数 | [optional]
 **orderBy** | [**\TencentAds\Model\ReportOrderByStruct[]**](../Model/\TencentAds\Model\ReportOrderByStruct.md)| 排序字段 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **timeLine** | **string**| 时间口径 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 指定返回的字段列表 | [optional]

### Return type

[**\TencentAds\Model\DailyReportsList**](../Model/DailyReportsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

