# TencentAds\DiagnosisApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**diagnosisGet**](DiagnosisApi.md#diagnosisGet) | **GET** /diagnosis/get | 广告诊断分析工具


# **diagnosisGet**
> \TencentAds\Model\DiagnosisList diagnosisGet($accountId, $adgroupIdList, $timeRange, $fields)

广告诊断分析工具

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: accessToken
$config = TencentAds\Configuration::getDefaultConfiguration()->setApiKey('access_token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = TencentAds\Configuration::getDefaultConfiguration()->setApiKeyPrefix('access_token', 'Bearer');
// Configure API key authorization: nonce
$config = TencentAds\Configuration::getDefaultConfiguration()->setApiKey('nonce', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = TencentAds\Configuration::getDefaultConfiguration()->setApiKeyPrefix('nonce', 'Bearer');
// Configure API key authorization: timestamp
$config = TencentAds\Configuration::getDefaultConfiguration()->setApiKey('timestamp', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = TencentAds\Configuration::getDefaultConfiguration()->setApiKeyPrefix('timestamp', 'Bearer');

$apiInstance = new TencentAds\Api\DiagnosisApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$accountId = 789; // int | 广告主id
$adgroupIdList = array(56); // int[] | 广告组id列表，最多可写入100个广告组id<br>每次写入的广告列表必须均为微信广告，或者均为非微信广告
$timeRange = array('key' => "timeRange_example"); // map[string,string] | 时间范围<br>仅当广告均为非微信广告时，此字段支持写入，且最多可选择日期为最近三天内的最长24小时区间。如果不填写，则默认返回最近两小时的数据。<br>微信广告暂不支持自定义查询时间范围，默认返回开始投放至今的所有数据
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $apiInstance->diagnosisGet($accountId, $adgroupIdList, $timeRange, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling DiagnosisApi->diagnosisGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主id |
 **adgroupIdList** | [**int[]**](../Model/int.md)| 广告组id列表，最多可写入100个广告组id&lt;br&gt;每次写入的广告列表必须均为微信广告，或者均为非微信广告 |
 **timeRange** | [**map[string,string]**](../Model/string.md)| 时间范围&lt;br&gt;仅当广告均为非微信广告时，此字段支持写入，且最多可选择日期为最近三天内的最长24小时区间。如果不填写，则默认返回最近两小时的数据。&lt;br&gt;微信广告暂不支持自定义查询时间范围，默认返回开始投放至今的所有数据 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\DiagnosisList**](../Model/DiagnosisList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

