# TencentAds\DynamicAdImagesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**dynamicAdImagesAdd**](DynamicAdImagesApi.md#dynamicAdImagesAdd) | **POST** /dynamic_ad_images/add | 创建用于广告投放的动态广告图片
[**dynamicAdImagesGet**](DynamicAdImagesApi.md#dynamicAdImagesGet) | **GET** /dynamic_ad_images/get | 获取动态广告图片信息


# **dynamicAdImagesAdd**
> \TencentAds\Model\DynamicAdImagesAddResponse dynamicAdImagesAdd($data)

创建用于广告投放的动态广告图片

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\DynamicAdImagesAddRequest(); // \TencentAds\Model\DynamicAdImagesAddRequest | 

try {
    $result = $tads->dynamicAdImages()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling dynamicAdImages()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\DynamicAdImagesAddRequest**](../Model/DynamicAdImagesAddRequest.md)|  |

### Return type

[**\TencentAds\Model\DynamicAdImagesAddResponse**](../Model/DynamicAdImagesAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **dynamicAdImagesGet**
> \TencentAds\Model\DynamicAdImagesList dynamicAdImagesGet($accountId, $filtering, $page, $pageSize, $fields)

获取动态广告图片信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\DynamicAdImagesFilteringStruct()); // \TencentAds\Model\DynamicAdImagesFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->dynamicAdImages()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling dynamicAdImages()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **filtering** | [**\TencentAds\Model\DynamicAdImagesFilteringStruct[]**](../Model/\TencentAds\Model\DynamicAdImagesFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\DynamicAdImagesList**](../Model/DynamicAdImagesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

