# TencentAds\DynamicAdTemplatesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**dynamicAdTemplatesGet**](DynamicAdTemplatesApi.md#dynamicAdTemplatesGet) | **GET** /dynamic_ad_templates/get | 获取动态模板信息


# **dynamicAdTemplatesGet**
> \TencentAds\Model\DynamicAdTemplatesList dynamicAdTemplatesGet($accountId, $productCatalogId, $dynamicAdTemplateWidth, $dynamicAdTemplateHeight, $dynamicAdTemplateType, $dynamicAdTemplateOwnershipType, $filtering, $page, $pageSize, $fields)

获取动态模板信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主id
$productCatalogId = 789; // int | 商品目录ID
$dynamicAdTemplateWidth = 789; // int | 动态商品模板宽度，单位 px
$dynamicAdTemplateHeight = 789; // int | 动态商品模板高度，单位 px
$dynamicAdTemplateType = "dynamicAdTemplateType_example"; // string | 动态商品模板类型
$dynamicAdTemplateOwnershipType = "dynamicAdTemplateOwnershipType_example"; // string | 动态商品模板所属类型
$filtering = array(new \TencentAds\Model\\TencentAds\Model\DynamicAdTemplatesGetFilteringStruct()); // \TencentAds\Model\DynamicAdTemplatesGetFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，获取指定页数据
$pageSize = 789; // int | 一页获取的数据条数
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->dynamicAdTemplates()->get($accountId, $productCatalogId, $dynamicAdTemplateWidth, $dynamicAdTemplateHeight, $dynamicAdTemplateType, $dynamicAdTemplateOwnershipType, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling dynamicAdTemplates()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主id |
 **productCatalogId** | **int**| 商品目录ID |
 **dynamicAdTemplateWidth** | **int**| 动态商品模板宽度，单位 px |
 **dynamicAdTemplateHeight** | **int**| 动态商品模板高度，单位 px |
 **dynamicAdTemplateType** | **string**| 动态商品模板类型 | [optional]
 **dynamicAdTemplateOwnershipType** | **string**| 动态商品模板所属类型 | [optional]
 **filtering** | [**\TencentAds\Model\DynamicAdTemplatesGetFilteringStruct[]**](../Model/\TencentAds\Model\DynamicAdTemplatesGetFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，获取指定页数据 | [optional]
 **pageSize** | **int**| 一页获取的数据条数 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\DynamicAdTemplatesList**](../Model/DynamicAdTemplatesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

