# TencentAds\DynamicAdVideoApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**dynamicAdVideoAdd**](DynamicAdVideoApi.md#dynamicAdVideoAdd) | **POST** /dynamic_ad_video/add | 创建用于广告投放的动态广告视频


# **dynamicAdVideoAdd**
> \TencentAds\Model\DynamicAdVideoAddResponse dynamicAdVideoAdd($data)

创建用于广告投放的动态广告视频

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\DynamicAdVideoAddRequest(); // \TencentAds\Model\DynamicAdVideoAddRequest | 

try {
    $result = $tads->dynamicAdVideo()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling dynamicAdVideo()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\DynamicAdVideoAddRequest**](../Model/DynamicAdVideoAddRequest.md)|  |

### Return type

[**\TencentAds\Model\DynamicAdVideoAddResponse**](../Model/DynamicAdVideoAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

