# TencentAds\DynamicCreativesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**dynamicCreativesAdd**](DynamicCreativesApi.md#dynamicCreativesAdd) | **POST** /dynamic_creatives/add | 创建动态创意
[**dynamicCreativesGet**](DynamicCreativesApi.md#dynamicCreativesGet) | **GET** /dynamic_creatives/get | 获取动态广告创意列表
[**dynamicCreativesUpdate**](DynamicCreativesApi.md#dynamicCreativesUpdate) | **POST** /dynamic_creatives/update | 更新动态创意


# **dynamicCreativesAdd**
> \TencentAds\Model\DynamicCreativesAddResponse dynamicCreativesAdd($data)

创建动态创意

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\DynamicCreativesAddRequest(); // \TencentAds\Model\DynamicCreativesAddRequest | 

try {
    $result = $tads->dynamicCreatives()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling dynamicCreatives()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\DynamicCreativesAddRequest**](../Model/DynamicCreativesAddRequest.md)|  |

### Return type

[**\TencentAds\Model\DynamicCreativesAddResponse**](../Model/DynamicCreativesAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **dynamicCreativesGet**
> \TencentAds\Model\DynamicCreativesList dynamicCreativesGet($accountId, $filtering, $page, $pageSize, $fields)

获取动态广告创意列表

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\DynamicCreativeFilteringStruct()); // \TencentAds\Model\DynamicCreativeFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->dynamicCreatives()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling dynamicCreatives()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **filtering** | [**\TencentAds\Model\DynamicCreativeFilteringStruct[]**](../Model/\TencentAds\Model\DynamicCreativeFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\DynamicCreativesList**](../Model/DynamicCreativesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **dynamicCreativesUpdate**
> \TencentAds\Model\DynamicCreativesUpdateResponse dynamicCreativesUpdate($data)

更新动态创意

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\DynamicCreativesUpdateRequest(); // \TencentAds\Model\DynamicCreativesUpdateRequest | 

try {
    $result = $tads->dynamicCreatives()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling dynamicCreatives()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\DynamicCreativesUpdateRequest**](../Model/DynamicCreativesUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\DynamicCreativesUpdateResponse**](../Model/DynamicCreativesUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

