# TencentAds\EcommerceOrderApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ecommerceOrderGet**](EcommerceOrderApi.md#ecommerceOrderGet) | **GET** /ecommerce_order/get | 获取订单
[**ecommerceOrderUpdate**](EcommerceOrderApi.md#ecommerceOrderUpdate) | **POST** /ecommerce_order/update | 更新订单


# **ecommerceOrderGet**
> \TencentAds\Model\EcommerceOrderList ecommerceOrderGet($accountId, $dateRange, $filtering, $page, $pageSize, $fields)

获取订单

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，对订单有所有权的直客帐号或子客帐号
$dateRange = array('key' => "dateRange_example"); // map[string,string] | 日期范围
$filtering = array(new \TencentAds\Model\\TencentAds\Model\EcommerceOrderGetFilteringStruct()); // \TencentAds\Model\EcommerceOrderGetFilteringStruct[] | 过滤条件
$page = 789; // int | 页数
$pageSize = 789; // int | 分页大小
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->ecommerceOrder()->get($accountId, $dateRange, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ecommerceOrder()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，对订单有所有权的直客帐号或子客帐号 |
 **dateRange** | [**map[string,string]**](../Model/string.md)| 日期范围 |
 **filtering** | [**\TencentAds\Model\EcommerceOrderGetFilteringStruct[]**](../Model/\TencentAds\Model\EcommerceOrderGetFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 页数 | [optional]
 **pageSize** | **int**| 分页大小 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\EcommerceOrderList**](../Model/EcommerceOrderList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **ecommerceOrderUpdate**
> \TencentAds\Model\EcommerceOrderUpdateResponse ecommerceOrderUpdate($data)

更新订单

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\EcommerceOrderUpdateRequest(); // \TencentAds\Model\EcommerceOrderUpdateRequest | 

try {
    $result = $tads->ecommerceOrder()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling ecommerceOrder()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\EcommerceOrderUpdateRequest**](../Model/EcommerceOrderUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\EcommerceOrderUpdateResponse**](../Model/EcommerceOrderUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

