# TencentAds\EstimationApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**estimationGet**](EstimationApi.md#estimationGet) | **POST** /estimation/get | 预估覆盖人数


# **estimationGet**
> \TencentAds\Model\EstimationsList estimationGet($data)

预估覆盖人数

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\EstimationGetRequest(); // \TencentAds\Model\EstimationGetRequest | 

try {
    $result = $tads->estimation()->get($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling estimation()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\EstimationGetRequest**](../Model/EstimationGetRequest.md)|  |

### Return type

[**\TencentAds\Model\EstimationsList**](../Model/EstimationsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

