# TencentAds\FeatureDataFilesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**featureDataFilesAdd**](FeatureDataFilesApi.md#featureDataFilesAdd) | **POST** /feature_data_files/add | 添加特征数据文件
[**featureDataFilesGet**](FeatureDataFilesApi.md#featureDataFilesGet) | **GET** /feature_data_files/get | 获取特征数据文件


# **featureDataFilesAdd**
> \TencentAds\Model\FeatureDataFilesAddResponse featureDataFilesAdd($accountId, $userIdType, $file, $openAppId)

添加特征数据文件

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 帐号ID，包含品牌数据智库ID和生态数据智库ID
$userIdType = "userIdType_example"; // string | 用户id类型
$file = "/path/to/file.txt"; // \SplFileObject | 上传特征数据文件
$openAppId = "openAppId_example"; // string | 微信/QQ手机版 appid，当且仅当数据文件中的用户 id 类型为 'WECHAT_OPENID' 或 'MOBILE_QQ_OPENID' 时有效

try {
    $result = $tads->featureDataFiles()->add($accountId, $userIdType, $file, $openAppId);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling featureDataFiles()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 帐号ID，包含品牌数据智库ID和生态数据智库ID |
 **userIdType** | **string**| 用户id类型 |
 **file** | **\SplFileObject**| 上传特征数据文件 |
 **openAppId** | **string**| 微信/QQ手机版 appid，当且仅当数据文件中的用户 id 类型为 &#39;WECHAT_OPENID&#39; 或 &#39;MOBILE_QQ_OPENID&#39; 时有效 | [optional]

### Return type

[**\TencentAds\Model\FeatureDataFilesAddResponse**](../Model/FeatureDataFilesAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **featureDataFilesGet**
> \TencentAds\Model\FeatureDataFilesList featureDataFilesGet($accountId, $filtering, $page, $pageSize, $fields)

获取特征数据文件

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 帐号ID，包含品牌数据智库ID和生态数据智库ID
$filtering = array(new \TencentAds\Model\\TencentAds\Model\FeatureDataFilesGetSingleFilter()); // \TencentAds\Model\FeatureDataFilesGetSingleFilter[] | 过滤条件，若此字段不传，或传空则视为无限制条件，详见 <a href='/docs/reference/illustration#filtering' target='_blank'>[过滤条件]</a>
$page = 789; // int | 当前页码
$pageSize = 789; // int | 分页大小
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->featureDataFiles()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling featureDataFiles()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 帐号ID，包含品牌数据智库ID和生态数据智库ID |
 **filtering** | [**\TencentAds\Model\FeatureDataFilesGetSingleFilter[]**](../Model/\TencentAds\Model\FeatureDataFilesGetSingleFilter.md)| 过滤条件，若此字段不传，或传空则视为无限制条件，详见 &lt;a href&#x3D;&#39;/docs/reference/illustration#filtering&#39; target&#x3D;&#39;_blank&#39;&gt;[过滤条件]&lt;/a&gt; | [optional]
 **page** | **int**| 当前页码 | [optional]
 **pageSize** | **int**| 分页大小 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\FeatureDataFilesList**](../Model/FeatureDataFilesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

