# TencentAds\FundStatementsDailyApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**fundStatementsDailyGet**](FundStatementsDailyApi.md#fundStatementsDailyGet) | **GET** /fund_statements_daily/get | 获取资金账户日结明细


# **fundStatementsDailyGet**
> \TencentAds\Model\FundStatementsDailyList fundStatementsDailyGet($accountId, $fundType, $dateRange, $tradeType, $fields)

获取资金账户日结明细

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$fundType = "fundType_example"; // string | 资金账户类型
$dateRange = array('key' => "dateRange_example"); // map[string,string] | 日期范围
$tradeType = "tradeType_example"; // string | 交易类型
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->fundStatementsDaily()->get($accountId, $fundType, $dateRange, $tradeType, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling fundStatementsDaily()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **fundType** | **string**| 资金账户类型 |
 **dateRange** | [**map[string,string]**](../Model/string.md)| 日期范围 |
 **tradeType** | **string**| 交易类型 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\FundStatementsDailyList**](../Model/FundStatementsDailyList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

