# TencentAds\FundStatementsDetailedApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**fundStatementsDetailedGet**](FundStatementsDetailedApi.md#fundStatementsDetailedGet) | **GET** /fund_statements_detailed/get | 获取资金流水


# **fundStatementsDetailedGet**
> \TencentAds\Model\FundStatementsDetailedList fundStatementsDetailedGet($accountId, $fundType, $dateRange, $page, $pageSize, $fields)

获取资金流水

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$fundType = "fundType_example"; // string | 资金账户类型
$dateRange = array('key' => "dateRange_example"); // map[string,string] | 日期范围
$page = 789; // int | 按日期范围的总天数进行分页，每天一页
$pageSize = 789; // int | 每天固定返回 4 条记录（充值、消费、过期和回划）
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->fundStatementsDetailed()->get($accountId, $fundType, $dateRange, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling fundStatementsDetailed()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **fundType** | **string**| 资金账户类型 |
 **dateRange** | [**map[string,string]**](../Model/string.md)| 日期范围 |
 **page** | **int**| 按日期范围的总天数进行分页，每天一页 | [optional]
 **pageSize** | **int**| 每天固定返回 4 条记录（充值、消费、过期和回划） | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\FundStatementsDetailedList**](../Model/FundStatementsDetailedList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

