# TencentAds\FundTransferApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**fundTransferAdd**](FundTransferApi.md#fundTransferAdd) | **POST** /fund_transfer/add | 发起代理商与子客户之间转账


# **fundTransferAdd**
> \TencentAds\Model\FundTransferAddResponse fundTransferAdd($data)

发起代理商与子客户之间转账

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\FundTransferAddRequest(); // \TencentAds\Model\FundTransferAddRequest | 

try {
    $result = $tads->fundTransfer()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling fundTransfer()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\FundTransferAddRequest**](../Model/FundTransferAddRequest.md)|  |

### Return type

[**\TencentAds\Model\FundTransferAddResponse**](../Model/FundTransferAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

