# TencentAds\ImageProcessingApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**imageProcessingAdd**](ImageProcessingApi.md#imageProcessingAdd) | **POST** /image_processing/add | 进行图片处理


# **imageProcessingAdd**
> \TencentAds\Model\ImageProcessingAddResponse imageProcessingAdd($data)

进行图片处理

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\ImageProcessingAddeRequest(); // \TencentAds\Model\ImageProcessingAddeRequest | 

try {
    $result = $tads->imageProcessing()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling imageProcessing()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\ImageProcessingAddeRequest**](../Model/ImageProcessingAddeRequest.md)|  |

### Return type

[**\TencentAds\Model\ImageProcessingAddResponse**](../Model/ImageProcessingAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

