# TencentAds\ImagesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**imagesAdd**](ImagesApi.md#imagesAdd) | **POST** /images/add | 添加图片文件
[**imagesGet**](ImagesApi.md#imagesGet) | **GET** /images/get | 获取图片信息


# **imagesAdd**
> \TencentAds\Model\ImagesAddResponse imagesAdd($accountId, $uploadType, $signature, $file, $bytes)

添加图片文件

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$uploadType = "uploadType_example"; // string | 上传方式
$signature = "signature_example"; // string | 图片文件签名，使用图片文件的md5值，用于检查上传图片文件的完整性
$file = "/path/to/file.txt"; // \SplFileObject | 被上传的图片文件
$bytes = "bytes_example"; // string | 图片base64编码

try {
    $result = $tads->images()->add($accountId, $uploadType, $signature, $file, $bytes);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling images()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **uploadType** | **string**| 上传方式 |
 **signature** | **string**| 图片文件签名，使用图片文件的md5值，用于检查上传图片文件的完整性 |
 **file** | **\SplFileObject**| 被上传的图片文件 | [optional]
 **bytes** | **string**| 图片base64编码 | [optional]

### Return type

[**\TencentAds\Model\ImagesAddResponse**](../Model/ImagesAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **imagesGet**
> \TencentAds\Model\ImagesList imagesGet($accountId, $filtering, $page, $pageSize, $fields)

获取图片信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\ImageFilteringStruct()); // \TencentAds\Model\ImageFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->images()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling images()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **filtering** | [**\TencentAds\Model\ImageFilteringStruct[]**](../Model/\TencentAds\Model\ImageFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\ImagesList**](../Model/ImagesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

