# TencentAds\LeadsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**leadsGet**](LeadsApi.md#leadsGet) | **GET** /leads/get | 获取销售线索


# **leadsGet**
> \TencentAds\Model\LeadsList leadsGet($accountId, $timeRange, $positionType, $filtering, $page, $pageSize, $fields)

获取销售线索

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$timeRange = array('key' => "timeRange_example"); // map[string,string] | 时间范围：<br /> 1、最多支持查询最近1年的表单明细数据<br /> 2、单次查询的最长跨度为1年<br /> 3、该时间表示表单最后提交时间
$positionType = "positionType_example"; // string | 广告位类型
$filtering = array(new \TencentAds\Model\\TencentAds\Model\LeadsFilteringStruct()); // \TencentAds\Model\LeadsFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->leads()->get($accountId, $timeRange, $positionType, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling leads()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **timeRange** | [**map[string,string]**](../Model/string.md)| 时间范围：&lt;br /&gt; 1、最多支持查询最近1年的表单明细数据&lt;br /&gt; 2、单次查询的最长跨度为1年&lt;br /&gt; 3、该时间表示表单最后提交时间 |
 **positionType** | **string**| 广告位类型 |
 **filtering** | [**\TencentAds\Model\LeadsFilteringStruct[]**](../Model/\TencentAds\Model\LeadsFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\LeadsList**](../Model/LeadsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

