# TencentAds\PlayablePagesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**playablePagesAdd**](PlayablePagesApi.md#playablePagesAdd) | **POST** /playable_pages/add | 添加试玩素材
[**playablePagesGet**](PlayablePagesApi.md#playablePagesGet) | **GET** /playable_pages/get | 获取试玩素材


# **playablePagesAdd**
> \TencentAds\Model\PlayablePageAddResponse playablePagesAdd($accountId, $playablePageName, $materialFile)

添加试玩素材

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$playablePageName = "playablePageName_example"; // string | 试玩素材名称
$materialFile = "/path/to/file.txt"; // \SplFileObject | 试玩素材文件

try {
    $result = $tads->playablePages()->add($accountId, $playablePageName, $materialFile);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling playablePages()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **playablePageName** | **string**| 试玩素材名称 |
 **materialFile** | **\SplFileObject**| 试玩素材文件 |

### Return type

[**\TencentAds\Model\PlayablePageAddResponse**](../Model/PlayablePageAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **playablePagesGet**
> \TencentAds\Model\PlayablePageList playablePagesGet($accountId, $filtering, $page, $pageSize, $fields)

获取试玩素材

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\PlayablePagesGetFilteringStruct()); // \TencentAds\Model\PlayablePagesGetFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->playablePages()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling playablePages()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **filtering** | [**\TencentAds\Model\PlayablePagesGetFilteringStruct[]**](../Model/\TencentAds\Model\PlayablePagesGetFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\PlayablePageList**](../Model/PlayablePageList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

