# TencentAds\ProductCatalogsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**productCatalogsAdd**](ProductCatalogsApi.md#productCatalogsAdd) | **POST** /product_catalogs/add | 创建商品库
[**productCatalogsGet**](ProductCatalogsApi.md#productCatalogsGet) | **GET** /product_catalogs/get | 获取商品目录信息


# **productCatalogsAdd**
> \TencentAds\Model\ProductCatalogsAddResponse productCatalogsAdd($data)

创建商品库

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\ProductCatalogsAddRequest(); // \TencentAds\Model\ProductCatalogsAddRequest | 

try {
    $result = $tads->productCatalogs()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling productCatalogs()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\ProductCatalogsAddRequest**](../Model/ProductCatalogsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\ProductCatalogsAddResponse**](../Model/ProductCatalogsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **productCatalogsGet**
> \TencentAds\Model\ProductCatalogsList productCatalogsGet($accountId, $page, $pageSize, $fields)

获取商品目录信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主ID
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->productCatalogs()->get($accountId, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling productCatalogs()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主ID |
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\ProductCatalogsList**](../Model/ProductCatalogsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

