# TencentAds\ProductCatalogsReportsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**productCatalogsReportsGet**](ProductCatalogsReportsApi.md#productCatalogsReportsGet) | **GET** /product_catalogs_reports/get | 获取商品库报表


# **productCatalogsReportsGet**
> \TencentAds\Model\ProductCatalogsReportsList productCatalogsReportsGet($accountId, $productCatalogId, $dateRange, $filtering, $groupBy, $orderBy, $fields)

获取商品库报表

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$productCatalogId = 789; // int | 商品库id
$dateRange = array('key' => "dateRange_example"); // map[string,string] | 日期范围
$filtering = array(new \TencentAds\Model\\TencentAds\Model\ProductCatalogsReportsGetFilteringStruct()); // \TencentAds\Model\ProductCatalogsReportsGetFilteringStruct[] | 过滤条件
$groupBy = array("groupBy_example"); // string[] | 聚合参数
$orderBy = array(new \TencentAds\Model\\TencentAds\Model\ReportOrderByStruct()); // \TencentAds\Model\ReportOrderByStruct[] | 排序字段
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->productCatalogsReports()->get($accountId, $productCatalogId, $dateRange, $filtering, $groupBy, $orderBy, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling productCatalogsReports()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **productCatalogId** | **int**| 商品库id |
 **dateRange** | [**map[string,string]**](../Model/string.md)| 日期范围 |
 **filtering** | [**\TencentAds\Model\ProductCatalogsReportsGetFilteringStruct[]**](../Model/\TencentAds\Model\ProductCatalogsReportsGetFilteringStruct.md)| 过滤条件 | [optional]
 **groupBy** | [**string[]**](../Model/string.md)| 聚合参数 | [optional]
 **orderBy** | [**\TencentAds\Model\ReportOrderByStruct[]**](../Model/\TencentAds\Model\ReportOrderByStruct.md)| 排序字段 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\ProductCatalogsReportsList**](../Model/ProductCatalogsReportsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

