# TencentAds\ProductItemsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**productItemsAdd**](ProductItemsApi.md#productItemsAdd) | **POST** /product_items/add | 添加商品
[**productItemsGet**](ProductItemsApi.md#productItemsGet) | **GET** /product_items/get | 获取商品
[**productItemsUpdate**](ProductItemsApi.md#productItemsUpdate) | **POST** /product_items/update | 更新商品信息


# **productItemsAdd**
> \TencentAds\Model\ProductItemsAddResponse productItemsAdd($data)

添加商品

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\ProductItemsAddRequest(); // \TencentAds\Model\ProductItemsAddRequest | 

try {
    $result = $tads->productItems()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling productItems()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\ProductItemsAddRequest**](../Model/ProductItemsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\ProductItemsAddResponse**](../Model/ProductItemsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **productItemsGet**
> \TencentAds\Model\ProductItemsList productItemsGet($accountId, $productCatalogId, $filtering, $fields)

获取商品

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主id
$productCatalogId = 789; // int | 商品目录ID
$filtering = array(new \TencentAds\Model\\TencentAds\Model\ProductItemsFilteringStruct()); // \TencentAds\Model\ProductItemsFilteringStruct[] | 过滤条件
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->productItems()->get($accountId, $productCatalogId, $filtering, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling productItems()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主id |
 **productCatalogId** | **int**| 商品目录ID |
 **filtering** | [**\TencentAds\Model\ProductItemsFilteringStruct[]**](../Model/\TencentAds\Model\ProductItemsFilteringStruct.md)| 过滤条件 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\ProductItemsList**](../Model/ProductItemsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **productItemsUpdate**
> \TencentAds\Model\ProductItemsUpdateResponse productItemsUpdate($data)

更新商品信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\ProductItemsUpdateRequest(); // \TencentAds\Model\ProductItemsUpdateRequest | 

try {
    $result = $tads->productItems()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling productItems()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\ProductItemsUpdateRequest**](../Model/ProductItemsUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\ProductItemsUpdateResponse**](../Model/ProductItemsUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

