# TencentAds\ProductItemsDetailApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**productItemsDetailGet**](ProductItemsDetailApi.md#productItemsDetailGet) | **GET** /product_items_detail/get | 获取商品详情


# **productItemsDetailGet**
> \TencentAds\Model\ProductItemsDetailList productItemsDetailGet($accountId, $productCatalogId, $productOuterId, $fields)

获取商品详情

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主id
$productCatalogId = 789; // int | 商品库ID
$productOuterId = "productOuterId_example"; // string | 广告主商品ID
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->productItemsDetail()->get($accountId, $productCatalogId, $productOuterId, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling productItemsDetail()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主id |
 **productCatalogId** | **int**| 商品库ID |
 **productOuterId** | **string**| 广告主商品ID |
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\ProductItemsDetailList**](../Model/ProductItemsDetailList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

