# TencentAds\ProductsSystemStatusApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**productsSystemStatusGet**](ProductsSystemStatusApi.md#productsSystemStatusGet) | **GET** /products_system_status/get | 获取审核失败的商品


# **productsSystemStatusGet**
> \TencentAds\Model\ProductsSystemStatusList productsSystemStatusGet($accountId, $productCatalogId, $feedId, $page, $pageSize, $fields)

获取审核失败的商品

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主id
$productCatalogId = 789; // int | 商品库ID
$feedId = 789; // int | 商品文件id
$page = 789; // int | 搜索页码，默认值：1 最小值 1，最大值 99999
$pageSize = 789; // int | 一页显示的数据条数
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->productsSystemStatus()->get($accountId, $productCatalogId, $feedId, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling productsSystemStatus()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主id |
 **productCatalogId** | **int**| 商品库ID |
 **feedId** | **int**| 商品文件id | [optional]
 **page** | **int**| 搜索页码，默认值：1 最小值 1，最大值 99999 | [optional]
 **pageSize** | **int**| 一页显示的数据条数 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\ProductsSystemStatusList**](../Model/ProductsSystemStatusList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

