# TencentAds\PromotedObjectsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**promotedObjectsAdd**](PromotedObjectsApi.md#promotedObjectsAdd) | **POST** /promoted_objects/add | 创建推广目标
[**promotedObjectsGet**](PromotedObjectsApi.md#promotedObjectsGet) | **GET** /promoted_objects/get | 获取推广目标
[**promotedObjectsUpdate**](PromotedObjectsApi.md#promotedObjectsUpdate) | **POST** /promoted_objects/update | 更新推广目标


# **promotedObjectsAdd**
> \TencentAds\Model\PromotedObjectsAddResponse promotedObjectsAdd($data)

创建推广目标

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\PromotedObjectsAddRequest(); // \TencentAds\Model\PromotedObjectsAddRequest | 

try {
    $result = $tads->promotedObjects()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling promotedObjects()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\PromotedObjectsAddRequest**](../Model/PromotedObjectsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\PromotedObjectsAddResponse**](../Model/PromotedObjectsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **promotedObjectsGet**
> \TencentAds\Model\PromotedObjectsList promotedObjectsGet($accountId, $filtering, $page, $pageSize, $fields)

获取推广目标

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\PromotedObjectFilteringStruct()); // \TencentAds\Model\PromotedObjectFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->promotedObjects()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling promotedObjects()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **filtering** | [**\TencentAds\Model\PromotedObjectFilteringStruct[]**](../Model/\TencentAds\Model\PromotedObjectFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\PromotedObjectsList**](../Model/PromotedObjectsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **promotedObjectsUpdate**
> \TencentAds\Model\PromotedObjectsUpdateResponse promotedObjectsUpdate($data)

更新推广目标

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\PromotedObjectsUpdateRequest(); // \TencentAds\Model\PromotedObjectsUpdateRequest | 

try {
    $result = $tads->promotedObjects()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling promotedObjects()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\PromotedObjectsUpdateRequest**](../Model/PromotedObjectsUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\PromotedObjectsUpdateResponse**](../Model/PromotedObjectsUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

