# TencentAds\QualificationsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**qualificationsAdd**](QualificationsApi.md#qualificationsAdd) | **POST** /qualifications/add | 创建广告主资质
[**qualificationsDelete**](QualificationsApi.md#qualificationsDelete) | **POST** /qualifications/delete | 删除广告主资质
[**qualificationsGet**](QualificationsApi.md#qualificationsGet) | **GET** /qualifications/get | 获取广告主资质
[**qualificationsUpdate**](QualificationsApi.md#qualificationsUpdate) | **POST** /qualifications/update | 更新广告主资质


# **qualificationsAdd**
> \TencentAds\Model\QualificationsAddResponse qualificationsAdd($data)

创建广告主资质

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\QualificationsAddRequest(); // \TencentAds\Model\QualificationsAddRequest | 

try {
    $result = $tads->qualifications()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling qualifications()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\QualificationsAddRequest**](../Model/QualificationsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\QualificationsAddResponse**](../Model/QualificationsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **qualificationsDelete**
> \TencentAds\Model\QualificationsDeleteResponse qualificationsDelete($data)

删除广告主资质

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\QualificationsDeleteRequest(); // \TencentAds\Model\QualificationsDeleteRequest | 

try {
    $result = $tads->qualifications()->delete($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling qualifications()->delete(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\QualificationsDeleteRequest**](../Model/QualificationsDeleteRequest.md)|  |

### Return type

[**\TencentAds\Model\QualificationsDeleteResponse**](../Model/QualificationsDeleteResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **qualificationsGet**
> \TencentAds\Model\QualificationsList qualificationsGet($accountId, $qualificationType, $filtering, $fields)

获取广告主资质

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$qualificationType = "qualificationType_example"; // string | 资质类型
$filtering = array(new \TencentAds\Model\\TencentAds\Model\QualificationsFilteringStruct()); // \TencentAds\Model\QualificationsFilteringStruct[] | 过滤条件
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->qualifications()->get($accountId, $qualificationType, $filtering, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling qualifications()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **qualificationType** | **string**| 资质类型 |
 **filtering** | [**\TencentAds\Model\QualificationsFilteringStruct[]**](../Model/\TencentAds\Model\QualificationsFilteringStruct.md)| 过滤条件 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\QualificationsList**](../Model/QualificationsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **qualificationsUpdate**
> \TencentAds\Model\QualificationsUpdateResponse qualificationsUpdate($data)

更新广告主资质

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\QualificationsUpdateRequest(); // \TencentAds\Model\QualificationsUpdateRequest | 

try {
    $result = $tads->qualifications()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling qualifications()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\QualificationsUpdateRequest**](../Model/QualificationsUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\QualificationsUpdateResponse**](../Model/QualificationsUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

