# TencentAds\RealtimeCostApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**realtimeCostGet**](RealtimeCostApi.md#realtimeCostGet) | **GET** /realtime_cost/get | 获取实时消耗


# **realtimeCostGet**
> \TencentAds\Model\RealtimeCostList realtimeCostGet($accountId, $level, $date, $filtering, $page, $pageSize, $fields)

获取实时消耗

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$level = "level_example"; // string | 获取实时消耗的类型级别
$date = "date_example"; // string | 日期，查询日期，日期格式： YYYY-MM-DD ，只支持今天的数据查询
$filtering = array(new \TencentAds\Model\\TencentAds\Model\RealTimeCostFilteringStruct()); // \TencentAds\Model\RealTimeCostFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->realtimeCost()->get($accountId, $level, $date, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling realtimeCost()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **level** | **string**| 获取实时消耗的类型级别 |
 **date** | **string**| 日期，查询日期，日期格式： YYYY-MM-DD ，只支持今天的数据查询 |
 **filtering** | [**\TencentAds\Model\RealTimeCostFilteringStruct[]**](../Model/\TencentAds\Model\RealTimeCostFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\RealtimeCostList**](../Model/RealtimeCostList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

