# TencentAds\SplitTestsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**splitTestsAdd**](SplitTestsApi.md#splitTestsAdd) | **POST** /split_tests/add | 创建拆分对比实验
[**splitTestsDelete**](SplitTestsApi.md#splitTestsDelete) | **POST** /split_tests/delete | 删除拆分对比实验
[**splitTestsGet**](SplitTestsApi.md#splitTestsGet) | **GET** /split_tests/get | 获取拆分对比实验
[**splitTestsUpdate**](SplitTestsApi.md#splitTestsUpdate) | **POST** /split_tests/update | 更新拆分对比实验


# **splitTestsAdd**
> \TencentAds\Model\SplitTestAddResponse splitTestsAdd($data)

创建拆分对比实验

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\SplitTestAddRequest(); // \TencentAds\Model\SplitTestAddRequest | 

try {
    $result = $tads->splitTests()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling splitTests()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\SplitTestAddRequest**](../Model/SplitTestAddRequest.md)|  |

### Return type

[**\TencentAds\Model\SplitTestAddResponse**](../Model/SplitTestAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **splitTestsDelete**
> \TencentAds\Model\SplitTestDeleteResponse splitTestsDelete($data)

删除拆分对比实验

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\SplitTestDeleteRequest(); // \TencentAds\Model\SplitTestDeleteRequest | 

try {
    $result = $tads->splitTests()->delete($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling splitTests()->delete(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\SplitTestDeleteRequest**](../Model/SplitTestDeleteRequest.md)|  |

### Return type

[**\TencentAds\Model\SplitTestDeleteResponse**](../Model/SplitTestDeleteResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **splitTestsGet**
> \TencentAds\Model\SplitTestList splitTestsGet($accountId, $filtering, $page, $pageSize, $fields)

获取拆分对比实验

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\SplitTestFilteringStruct()); // \TencentAds\Model\SplitTestFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，获取指定页数据
$pageSize = 789; // int | 一页获取的数据条数
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->splitTests()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling splitTests()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主id |
 **filtering** | [**\TencentAds\Model\SplitTestFilteringStruct[]**](../Model/\TencentAds\Model\SplitTestFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，获取指定页数据 | [optional]
 **pageSize** | **int**| 一页获取的数据条数 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\SplitTestList**](../Model/SplitTestList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **splitTestsUpdate**
> \TencentAds\Model\SplitTestUpdateResponse splitTestsUpdate($data)

更新拆分对比实验

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\SplitTestUpdateRequest(); // \TencentAds\Model\SplitTestUpdateRequest | 

try {
    $result = $tads->splitTests()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling splitTests()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\SplitTestUpdateRequest**](../Model/SplitTestUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\SplitTestUpdateResponse**](../Model/SplitTestUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

