# TencentAds\SystemStatusApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**systemStatusGet**](SystemStatusApi.md#systemStatusGet) | **GET** /system_status/get | 获取广告组系统状态信息


# **systemStatusGet**
> \TencentAds\Model\SystemStatusList systemStatusGet($accountId, $statusType, $statusSpec, $fields)

获取广告组系统状态信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$statusType = "statusType_example"; // string | 状态类型
$statusSpec = array('key' => "statusSpec_example"); // map[string,string] | 获取系统状态所需条件
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->systemStatus()->get($accountId, $statusType, $statusSpec, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling systemStatus()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **statusType** | **string**| 状态类型 |
 **statusSpec** | [**map[string,string]**](../Model/string.md)| 获取系统状态所需条件 |
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\SystemStatusList**](../Model/SystemStatusList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

