# TencentAds\TargetingTagsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**targetingTagsGet**](TargetingTagsApi.md#targetingTagsGet) | **GET** /targeting_tags/get | 获取定向标签


# **targetingTagsGet**
> \TencentAds\Model\TargetingTagsList targetingTagsGet($type, $tagSpec, $fields)

获取定向标签

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$type = "type_example"; // string | 标签类型
$tagSpec = array('key' => "tagSpec_example"); // map[string,string] | 获取定向标签的条件
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->targetingTags()->get($type, $tagSpec, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling targetingTags()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **type** | **string**| 标签类型 |
 **tagSpec** | [**map[string,string]**](../Model/string.md)| 获取定向标签的条件 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\TargetingTagsList**](../Model/TargetingTagsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

