# TencentAds\TargetingsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**targetingsAdd**](TargetingsApi.md#targetingsAdd) | **POST** /targetings/add | 创建定向
[**targetingsDelete**](TargetingsApi.md#targetingsDelete) | **POST** /targetings/delete | 删除定向
[**targetingsGet**](TargetingsApi.md#targetingsGet) | **GET** /targetings/get | 获取定向
[**targetingsUpdate**](TargetingsApi.md#targetingsUpdate) | **POST** /targetings/update | 更新定向


# **targetingsAdd**
> \TencentAds\Model\TargetingsAddResponse targetingsAdd($data)

创建定向

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\TargetingsAddRequest(); // \TencentAds\Model\TargetingsAddRequest | 

try {
    $result = $tads->targetings()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling targetings()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\TargetingsAddRequest**](../Model/TargetingsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\TargetingsAddResponse**](../Model/TargetingsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **targetingsDelete**
> \TencentAds\Model\TargetingsDeleteResponse targetingsDelete($data)

删除定向

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\TargetingsDeleteRequest(); // \TencentAds\Model\TargetingsDeleteRequest | 

try {
    $result = $tads->targetings()->delete($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling targetings()->delete(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\TargetingsDeleteRequest**](../Model/TargetingsDeleteRequest.md)|  |

### Return type

[**\TencentAds\Model\TargetingsDeleteResponse**](../Model/TargetingsDeleteResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **targetingsGet**
> \TencentAds\Model\TargetingsList targetingsGet($accountId, $filtering, $page, $pageSize, $fields)

获取定向

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\TargetingFilteringStruct()); // \TencentAds\Model\TargetingFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->targetings()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling targetings()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **filtering** | [**\TencentAds\Model\TargetingFilteringStruct[]**](../Model/\TencentAds\Model\TargetingFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\TargetingsList**](../Model/TargetingsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **targetingsUpdate**
> \TencentAds\Model\TargetingsUpdateResponse targetingsUpdate($data)

更新定向

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\TargetingsUpdateRequest(); // \TencentAds\Model\TargetingsUpdateRequest | 

try {
    $result = $tads->targetings()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling targetings()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\TargetingsUpdateRequest**](../Model/TargetingsUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\TargetingsUpdateResponse**](../Model/TargetingsUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

