# TencentAds\TrackingReportsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**trackingReportsGet**](TrackingReportsApi.md#trackingReportsGet) | **GET** /tracking_reports/get | 点击追踪报表


# **trackingReportsGet**
> \TencentAds\Model\TrackingReportsList trackingReportsGet($accountId, $dateRange, $timeGranularity, $promotedObjectType, $promotedObjectId, $feedbackUrl, $page, $pageSize, $fields)

点击追踪报表

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$dateRange = array('key' => "dateRange_example"); // map[string,string] | 日期范围
$timeGranularity = "timeGranularity_example"; // string | 时间粒度
$promotedObjectType = "promotedObjectType_example"; // string | 推广目标类型
$promotedObjectId = "promotedObjectId_example"; // string | 推广目标id，详见 <a href='/docs/api/business_assets/promoted_objects/promoted_objects_get' target='_blank'>[查询推广目标id]</a>
$feedbackUrl = "feedbackUrl_example"; // string | 转发点击的url地址
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->trackingReports()->get($accountId, $dateRange, $timeGranularity, $promotedObjectType, $promotedObjectId, $feedbackUrl, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling trackingReports()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **dateRange** | [**map[string,string]**](../Model/string.md)| 日期范围 |
 **timeGranularity** | **string**| 时间粒度 | [optional]
 **promotedObjectType** | **string**| 推广目标类型 | [optional]
 **promotedObjectId** | **string**| 推广目标id，详见 &lt;a href&#x3D;&#39;/docs/api/business_assets/promoted_objects/promoted_objects_get&#39; target&#x3D;&#39;_blank&#39;&gt;[查询推广目标id]&lt;/a&gt; | [optional]
 **feedbackUrl** | **string**| 转发点击的url地址 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\TrackingReportsList**](../Model/TrackingReportsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

