# TencentAds\UnionPositionPackagesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**unionPositionPackagesAdd**](UnionPositionPackagesApi.md#unionPositionPackagesAdd) | **POST** /union_position_packages/add | 联盟流量包模块
[**unionPositionPackagesDelete**](UnionPositionPackagesApi.md#unionPositionPackagesDelete) | **POST** /union_position_packages/delete | 联盟流量包删除接口
[**unionPositionPackagesGet**](UnionPositionPackagesApi.md#unionPositionPackagesGet) | **GET** /union_position_packages/get | 联盟流量包获取接口


# **unionPositionPackagesAdd**
> \TencentAds\Model\UnionPositionPackagesAddResponse unionPositionPackagesAdd($data)

联盟流量包模块

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\UnionPositionPackagesAddRequest(); // \TencentAds\Model\UnionPositionPackagesAddRequest | 

try {
    $result = $tads->unionPositionPackages()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling unionPositionPackages()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\UnionPositionPackagesAddRequest**](../Model/UnionPositionPackagesAddRequest.md)|  |

### Return type

[**\TencentAds\Model\UnionPositionPackagesAddResponse**](../Model/UnionPositionPackagesAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **unionPositionPackagesDelete**
> \TencentAds\Model\UnionPositionPackagesDeleteResponse unionPositionPackagesDelete($data)

联盟流量包删除接口

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\UnionPositionPackagesDeleteRequest(); // \TencentAds\Model\UnionPositionPackagesDeleteRequest | 

try {
    $result = $tads->unionPositionPackages()->delete($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling unionPositionPackages()->delete(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\UnionPositionPackagesDeleteRequest**](../Model/UnionPositionPackagesDeleteRequest.md)|  |

### Return type

[**\TencentAds\Model\UnionPositionPackagesDeleteResponse**](../Model/UnionPositionPackagesDeleteResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **unionPositionPackagesGet**
> \TencentAds\Model\UnionPositionPackagesList unionPositionPackagesGet($accountId, $filtering, $page, $pageSize, $fields)

联盟流量包获取接口

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\UnionPositionPackagesFilteringStruct()); // \TencentAds\Model\UnionPositionPackagesFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，获取指定页数据
$pageSize = 789; // int | 一页获取的数据条数
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->unionPositionPackages()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling unionPositionPackages()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主id |
 **filtering** | [**\TencentAds\Model\UnionPositionPackagesFilteringStruct[]**](../Model/\TencentAds\Model\UnionPositionPackagesFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，获取指定页数据 | [optional]
 **pageSize** | **int**| 一页获取的数据条数 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\UnionPositionPackagesList**](../Model/UnionPositionPackagesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

