# TencentAds\UserActionSetReportsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**userActionSetReportsGet**](UserActionSetReportsApi.md#userActionSetReportsGet) | **GET** /user_action_set_reports/get | 获取用户行为数据源报表


# **userActionSetReportsGet**
> \TencentAds\Model\UserActionSetReportsList userActionSetReportsGet($accountId, $userActionSetId, $dateRange, $timeGranularity, $aggregation, $fields)

获取用户行为数据源报表

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id
$userActionSetId = 789; // int | 用户行为源 id，通过 <a href='/docs/api/user_data/user_action_set/user_action_sets_add' target='_blank'>[user_action_sets 接口]</a> 创建用户行为源时分配的唯一 id
$dateRange = array('key' => "dateRange_example"); // map[string,string] | 时间范围
$timeGranularity = "timeGranularity_example"; // string | 时间粒度，针对流量的粒度，可选值：DAILY（按天汇总）, HOURLY（按小时汇总），默认小时
$aggregation = "aggregation_example"; // string | 聚合维度，是否将结果按照指定类型细分，可选值'DOMAIN', 'ACTION_TYPE'
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->userActionSetReports()->get($accountId, $userActionSetId, $dateRange, $timeGranularity, $aggregation, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling userActionSetReports()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **userActionSetId** | **int**| 用户行为源 id，通过 &lt;a href&#x3D;&#39;/docs/api/user_data/user_action_set/user_action_sets_add&#39; target&#x3D;&#39;_blank&#39;&gt;[user_action_sets 接口]&lt;/a&gt; 创建用户行为源时分配的唯一 id |
 **dateRange** | [**map[string,string]**](../Model/string.md)| 时间范围 |
 **timeGranularity** | **string**| 时间粒度，针对流量的粒度，可选值：DAILY（按天汇总）, HOURLY（按小时汇总），默认小时 |
 **aggregation** | **string**| 聚合维度，是否将结果按照指定类型细分，可选值&#39;DOMAIN&#39;, &#39;ACTION_TYPE&#39; | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\UserActionSetReportsList**](../Model/UserActionSetReportsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

