# TencentAds\UserActionSetsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**userActionSetsAdd**](UserActionSetsApi.md#userActionSetsAdd) | **POST** /user_action_sets/add | 创建用户行为数据源
[**userActionSetsGet**](UserActionSetsApi.md#userActionSetsGet) | **GET** /user_action_sets/get | 获取用户行为数据源


# **userActionSetsAdd**
> \TencentAds\Model\UserActionSetsAddResponse userActionSetsAdd($data)

创建用户行为数据源

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\UserActionSetsAddRequest(); // \TencentAds\Model\UserActionSetsAddRequest | 

try {
    $result = $tads->userActionSets()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling userActionSets()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\UserActionSetsAddRequest**](../Model/UserActionSetsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\UserActionSetsAddResponse**](../Model/UserActionSetsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **userActionSetsGet**
> \TencentAds\Model\UserActionSetsList userActionSetsGet($accountId, $userActionSetId, $fields)

获取用户行为数据源

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id
$userActionSetId = 789; // int | 用户行为源 id，通过 <a href='/docs/api/user_data/user_action_set/user_action_sets_add' target='_blank'>[user_action_sets 接口]</a> 创建用户行为源时分配的唯一 id
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->userActionSets()->get($accountId, $userActionSetId, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling userActionSets()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **userActionSetId** | **int**| 用户行为源 id，通过 &lt;a href&#x3D;&#39;/docs/api/user_data/user_action_set/user_action_sets_add&#39; target&#x3D;&#39;_blank&#39;&gt;[user_action_sets 接口]&lt;/a&gt; 创建用户行为源时分配的唯一 id | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\UserActionSetsList**](../Model/UserActionSetsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

