# TencentAds\UserPropertiesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**userPropertiesAdd**](UserPropertiesApi.md#userPropertiesAdd) | **POST** /user_properties/add | 上传用户属性数据


# **userPropertiesAdd**
> \TencentAds\Model\UserPropertiesAddResponse userPropertiesAdd($data)

上传用户属性数据

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\UserPropertiesAddRequest(); // \TencentAds\Model\UserPropertiesAddRequest | 

try {
    $result = $tads->userProperties()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling userProperties()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\UserPropertiesAddRequest**](../Model/UserPropertiesAddRequest.md)|  |

### Return type

[**\TencentAds\Model\UserPropertiesAddResponse**](../Model/UserPropertiesAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

