# TencentAds\UserPropertySetsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**userPropertySetsAdd**](UserPropertySetsApi.md#userPropertySetsAdd) | **POST** /user_property_sets/add | 创建用户属性数据源
[**userPropertySetsGet**](UserPropertySetsApi.md#userPropertySetsGet) | **GET** /user_property_sets/get | 获取用户属性数据源
[**userPropertySetsUpdate**](UserPropertySetsApi.md#userPropertySetsUpdate) | **POST** /user_property_sets/update | 更新用户属性数据源


# **userPropertySetsAdd**
> \TencentAds\Model\UserPropertySetsAddResponse userPropertySetsAdd($data)

创建用户属性数据源

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\UserPropertySetsAddRequest(); // \TencentAds\Model\UserPropertySetsAddRequest | 

try {
    $result = $tads->userPropertySets()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling userPropertySets()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\UserPropertySetsAddRequest**](../Model/UserPropertySetsAddRequest.md)|  |

### Return type

[**\TencentAds\Model\UserPropertySetsAddResponse**](../Model/UserPropertySetsAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **userPropertySetsGet**
> \TencentAds\Model\UserPropertySetsList userPropertySetsGet($accountId, $userPropertySetId, $fields)

获取用户属性数据源

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id
$userPropertySetId = 789; // int | 用户属性数据源ID
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->userPropertySets()->get($accountId, $userPropertySetId, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling userPropertySets()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **userPropertySetId** | **int**| 用户属性数据源ID | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\UserPropertySetsList**](../Model/UserPropertySetsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **userPropertySetsUpdate**
> \TencentAds\Model\UserPropertySetsUpdateResponse userPropertySetsUpdate($data)

更新用户属性数据源

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\UserPropertySetsUpdateRequest(); // \TencentAds\Model\UserPropertySetsUpdateRequest | 

try {
    $result = $tads->userPropertySets()->update($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling userPropertySets()->update(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\UserPropertySetsUpdateRequest**](../Model/UserPropertySetsUpdateRequest.md)|  |

### Return type

[**\TencentAds\Model\UserPropertySetsUpdateResponse**](../Model/UserPropertySetsUpdateResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

