# TencentAds\VideosApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**videosAdd**](VideosApi.md#videosAdd) | **POST** /videos/add | 添加视频文件
[**videosGet**](VideosApi.md#videosGet) | **GET** /videos/get | 获取视频文件


# **videosAdd**
> \TencentAds\Model\VideosAddResponse videosAdd($accountId, $videoFile, $signature, $description, $adcreativeTemplateId)

添加视频文件

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$videoFile = "/path/to/file.txt"; // \SplFileObject | 被上传的视频文件
$signature = "signature_example"; // string | 视频文件签名
$description = "description_example"; // string | 视频文件描述
$adcreativeTemplateId = 789; // int | 创意规格ID

try {
    $result = $tads->videos()->add($accountId, $videoFile, $signature, $description, $adcreativeTemplateId);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling videos()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **videoFile** | **\SplFileObject**| 被上传的视频文件 |
 **signature** | **string**| 视频文件签名 |
 **description** | **string**| 视频文件描述 | [optional]
 **adcreativeTemplateId** | **int**| 创意规格ID | [optional]

### Return type

[**\TencentAds\Model\VideosAddResponse**](../Model/VideosAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **videosGet**
> \TencentAds\Model\VideosList videosGet($accountId, $filtering, $page, $pageSize, $fields)

获取视频文件

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商 id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\MediaFilteringStruct()); // \TencentAds\Model\MediaFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->videos()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling videos()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商 id |
 **filtering** | [**\TencentAds\Model\MediaFilteringStruct[]**](../Model/\TencentAds\Model\MediaFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\VideosList**](../Model/VideosList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

