# TencentAds\WechatAdLabelsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**wechatAdLabelsGet**](WechatAdLabelsApi.md#wechatAdLabelsGet) | **GET** /wechat_ad_labels/get | 获取微信广告标签


# **wechatAdLabelsGet**
> \TencentAds\Model\WechatAdLabelsList wechatAdLabelsGet($accountId, $fields)

获取微信广告标签

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->wechatAdLabels()->get($accountId, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling wechatAdLabels()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id，有操作权限的帐号 id，包括代理商和广告主帐号id |
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\WechatAdLabelsList**](../Model/WechatAdLabelsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

