# TencentAds\WechatAdvertiserApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**wechatAdvertiserGet**](WechatAdvertiserApi.md#wechatAdvertiserGet) | **GET** /wechat_advertiser/get | 获取微信广告主信息


# **wechatAdvertiserGet**
> \TencentAds\Model\WechatAdvertiserList wechatAdvertiserGet($page, $pageSize, $fields)

获取微信广告主信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$page = 789; // int | 搜索页码，获取指定页数据
$pageSize = 789; // int | 一页获取的数据条数
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->wechatAdvertiser()->get($page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling wechatAdvertiser()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **page** | **int**| 搜索页码，获取指定页数据 | [optional]
 **pageSize** | **int**| 一页获取的数据条数 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\WechatAdvertiserList**](../Model/WechatAdvertiserList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

