# TencentAds\WechatAdvertiserDetailApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**wechatAdvertiserDetailGet**](WechatAdvertiserDetailApi.md#wechatAdvertiserDetailGet) | **GET** /wechat_advertiser_detail/get | 获取微信广告主信息


# **wechatAdvertiserDetailGet**
> \TencentAds\Model\WechatAdvertiserDetailList wechatAdvertiserDetailGet($accountId, $filtering, $page, $pageSize, $fields)

获取微信广告主信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 推广帐号 id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\WechatAdvertiserFilteringStruct()); // \TencentAds\Model\WechatAdvertiserFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->wechatAdvertiserDetail()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling wechatAdvertiserDetail()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 推广帐号 id | [optional]
 **filtering** | [**\TencentAds\Model\WechatAdvertiserFilteringStruct[]**](../Model/\TencentAds\Model\WechatAdvertiserFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\WechatAdvertiserDetailList**](../Model/WechatAdvertiserDetailList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

