# TencentAds\WechatFundStatementsDetailedApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**wechatFundStatementsDetailedGet**](WechatFundStatementsDetailedApi.md#wechatFundStatementsDetailedGet) | **GET** /wechat_fund_statements_detailed/get | 获取微信资金账户流水信息


# **wechatFundStatementsDetailedGet**
> \TencentAds\Model\WechatFundStatementsDetailedList wechatFundStatementsDetailedGet($tradeType, $dateRange, $filtering, $page, $pageSize, $fields)

获取微信资金账户流水信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$tradeType = "tradeType_example"; // string | 交易类型
$dateRange = array('key' => "dateRange_example"); // map[string,string] | 日期范围
$filtering = array(new \TencentAds\Model\\TencentAds\Model\WechatFundStatementsDetailedGetFilteringStruct()); // \TencentAds\Model\WechatFundStatementsDetailedGetFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->wechatFundStatementsDetailed()->get($tradeType, $dateRange, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling wechatFundStatementsDetailed()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tradeType** | **string**| 交易类型 |
 **dateRange** | [**map[string,string]**](../Model/string.md)| 日期范围 |
 **filtering** | [**\TencentAds\Model\WechatFundStatementsDetailedGetFilteringStruct[]**](../Model/\TencentAds\Model\WechatFundStatementsDetailedGetFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\WechatFundStatementsDetailedList**](../Model/WechatFundStatementsDetailedList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

