# TencentAds\WechatFundsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**wechatFundsGet**](WechatFundsApi.md#wechatFundsGet) | **GET** /wechat_funds/get | 获取微信资金账户信息


# **wechatFundsGet**
> \TencentAds\Model\WechatFundsList wechatFundsGet($accountId, $fields)

获取微信资金账户信息

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主id
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->wechatFunds()->get($accountId, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling wechatFunds()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主id |
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\WechatFundsList**](../Model/WechatFundsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

