# TencentAds\WechatLeadsApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**wechatLeadsGet**](WechatLeadsApi.md#wechatLeadsGet) | **GET** /wechat_leads/get | 获取销售线索


# **wechatLeadsGet**
> \TencentAds\Model\WechatLeadsList wechatLeadsGet($dateRange, $timeRange, $filtering, $page, $pageSize, $fields)

获取销售线索

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$dateRange = array('key' => "dateRange_example"); // map[string,string] | 时间范围（即将废弃，请使用time_range），根据表单最后提交时间进行查询，默认查询当天的数据，最长跨度1年，最多支持下载最近1年的表单明细数据
$timeRange = array('key' => "timeRange_example"); // map[string,string] | 时间范围，根据表单最后提交时间进行查询。date_range和time_range只能填写一项。默认查询当天的数据，最长跨度1年，最多支持下载最近1年的表单明细数据
$filtering = array(new \TencentAds\Model\\TencentAds\Model\WechatLeadsFilteringStruct()); // \TencentAds\Model\WechatLeadsFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->wechatLeads()->get($dateRange, $timeRange, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling wechatLeads()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dateRange** | [**map[string,string]**](../Model/string.md)| 时间范围（即将废弃，请使用time_range），根据表单最后提交时间进行查询，默认查询当天的数据，最长跨度1年，最多支持下载最近1年的表单明细数据 | [optional]
 **timeRange** | [**map[string,string]**](../Model/string.md)| 时间范围，根据表单最后提交时间进行查询。date_range和time_range只能填写一项。默认查询当天的数据，最长跨度1年，最多支持下载最近1年的表单明细数据 | [optional]
 **filtering** | [**\TencentAds\Model\WechatLeadsFilteringStruct[]**](../Model/\TencentAds\Model\WechatLeadsFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\WechatLeadsList**](../Model/WechatLeadsList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

