# TencentAds\WechatPagesApi

All URIs are relative to *https://sandbox-api.e.qq.com/v1.1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**wechatPagesAdd**](WechatPagesApi.md#wechatPagesAdd) | **POST** /wechat_pages/add | 创建微信落地页
[**wechatPagesDelete**](WechatPagesApi.md#wechatPagesDelete) | **POST** /wechat_pages/delete | 删除微信落地页
[**wechatPagesGet**](WechatPagesApi.md#wechatPagesGet) | **GET** /wechat_pages/get | 获取微信落地页列表


# **wechatPagesAdd**
> \TencentAds\Model\WechatPagesAddResponse wechatPagesAdd($data)

创建微信落地页

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\WechatPagesAddRequest(); // \TencentAds\Model\WechatPagesAddRequest | 

try {
    $result = $tads->wechatPages()->add($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling wechatPages()->add(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\WechatPagesAddRequest**](../Model/WechatPagesAddRequest.md)|  |

### Return type

[**\TencentAds\Model\WechatPagesAddResponse**](../Model/WechatPagesAddResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **wechatPagesDelete**
> \TencentAds\Model\WechatPagesDeleteResponse wechatPagesDelete($data)

删除微信落地页

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$data = new \TencentAds\Model\WechatPagesDeleteRequest(); // \TencentAds\Model\WechatPagesDeleteRequest | 

try {
    $result = $tads->wechatPages()->delete($data);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling wechatPages()->delete(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **data** | [**\TencentAds\Model\WechatPagesDeleteRequest**](../Model/WechatPagesDeleteRequest.md)|  |

### Return type

[**\TencentAds\Model\WechatPagesDeleteResponse**](../Model/WechatPagesDeleteResponse.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: application/json, application/xml
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **wechatPagesGet**
> \TencentAds\Model\WechatPagesList wechatPagesGet($accountId, $filtering, $page, $pageSize, $fields)

获取微信落地页列表

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

use TencentAds\TencentAds;

$tads = TencentAds::init([
            'access_token' => 'YOUR_ACCESS_TOKEN',
            'is_debug'     => true,
        ]);
$accountId = 789; // int | 广告主帐号 id，有操作权限的帐号 id，不支持代理商id
$filtering = array(new \TencentAds\Model\\TencentAds\Model\WechatPagesGetFilteringStruct()); // \TencentAds\Model\WechatPagesGetFilteringStruct[] | 过滤条件
$page = 789; // int | 搜索页码，默认值：1
$pageSize = 789; // int | 一页显示的数据条数，默认值：10
$fields = array("fields_example"); // string[] | 返回参数的字段列表

try {
    $result = $tads->wechatPages()->get($accountId, $filtering, $page, $pageSize, $fields);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling wechatPages()->get(): ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **int**| 广告主帐号 id，有操作权限的帐号 id，不支持代理商id |
 **filtering** | [**\TencentAds\Model\WechatPagesGetFilteringStruct[]**](../Model/\TencentAds\Model\WechatPagesGetFilteringStruct.md)| 过滤条件 | [optional]
 **page** | **int**| 搜索页码，默认值：1 | [optional]
 **pageSize** | **int**| 一页显示的数据条数，默认值：10 | [optional]
 **fields** | [**string[]**](../Model/string.md)| 返回参数的字段列表 | [optional]

### Return type

[**\TencentAds\Model\WechatPagesList**](../Model/WechatPagesList.md)

### Authorization

[accessToken](../../README.md#accessToken), [nonce](../../README.md#nonce), [timestamp](../../README.md#timestamp)

### HTTP request headers

 - **Content-Type**: text/plain
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

