<?php
require_once __DIR__ . '/vendor/ams-marketing-sdk-php/vendor/autoload.php'; // change path as needed
use TencentAds\TencentAds;
use TencentAds\Exception\TencentAdsResponseException;
use TencentAds\Exception\TencentAdsSDKException;
$tads = TencentAds::init([
    'access_token' => '{your access token}',
    'is_debug' => true,
    'debug_file' => '{your log path}'
]);
try {
    $filtering = [[
        'field' => 'promoted_object_type',
        'operator' => 'EQUALS',
        'values' => ['PROMOTED_OBJECT_TYPE_APP_IOS'],
    ]];
    $response = $tads->useSandbox() //默认访问沙箱环境，如访问生产环境，请切换为$tads->useProduction()
        ->campaigns()
        ->get([
            'account_id' => '{your account id}',
            'filtering' => $filtering
        ]);
    echo "<pre>" . PHP_EOL;
    print_r($response);
    echo "</pre>" . PHP_EOL;
} catch(TencentAdsResponseException $e) {
    // When Api returns an error
    echo 'Tencent ads returned an error: ' . $e->getMessage();
    exit;
} catch(TencentAdsSDKException $e) {
    // When validation fails or other local issues
    echo 'Tencent ads SDK returned an error: ' . $e->getMessage();
    exit;
}
