<?php
/**
 * CustomAudienceFilesApi
 * PHP version 5
 *
 * @category Class
 * @package  TencentAds
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Marketing API
 *
 * Marketing API
 *
 * OpenAPI spec version: 1.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.4.13
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace TencentAds\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use TencentAds\ApiException;
use TencentAds\Configuration;
use TencentAds\HeaderSelector;
use TencentAds\ObjectSerializer;

/**
 * CustomAudienceFilesApi Class Doc Comment
 *
 * @category Class
 * @package  TencentAds
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class CustomAudienceFilesApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation customAudienceFilesAdd
     *
     * 上传客户人群数据文件
     *
     * @param  int $accountId 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id (required)
     * @param  int $audienceId 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得 (required)
     * @param  string $userIdType 号码包用户ID类型 (required)
     * @param  \SplFileObject $file 上传人群文件 (required)
     * @param  string $operationType 文件操作类型 (optional)
     * @param  string $saltId 数据加密的盐 id，当且仅当数据文件中的用户 id 类型为 &#39;SALTED_HASH_IMEI&#39; 或 &#39;SALTED_HASH_IDFA&#39; 时有效 (optional)
     *
     * @throws \TencentAds\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \TencentAds\Model\CustomAudienceFilesAddResponse
     */
    public function customAudienceFilesAdd($accountId, $audienceId, $userIdType, $file, $operationType = null, $saltId = null)
    {
        list($response) = $this->customAudienceFilesAddWithHttpInfo($accountId, $audienceId, $userIdType, $file, $operationType, $saltId);
        return $response;
    }

    /**
     * Operation customAudienceFilesAddWithHttpInfo
     *
     * 上传客户人群数据文件
     *
     * @param  int $accountId 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id (required)
     * @param  int $audienceId 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得 (required)
     * @param  string $userIdType 号码包用户ID类型 (required)
     * @param  \SplFileObject $file 上传人群文件 (required)
     * @param  string $operationType 文件操作类型 (optional)
     * @param  string $saltId 数据加密的盐 id，当且仅当数据文件中的用户 id 类型为 &#39;SALTED_HASH_IMEI&#39; 或 &#39;SALTED_HASH_IDFA&#39; 时有效 (optional)
     *
     * @throws \TencentAds\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \TencentAds\Model\CustomAudienceFilesAddResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function customAudienceFilesAddWithHttpInfo($accountId, $audienceId, $userIdType, $file, $operationType = null, $saltId = null)
    {
        $returnType = '\TencentAds\Model\CustomAudienceFilesAddResponse';
        $request = $this->customAudienceFilesAddRequest($accountId, $audienceId, $userIdType, $file, $operationType, $saltId);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\TencentAds\Model\CustomAudienceFilesAddResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation customAudienceFilesAddAsync
     *
     * 上传客户人群数据文件
     *
     * @param  int $accountId 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id (required)
     * @param  int $audienceId 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得 (required)
     * @param  string $userIdType 号码包用户ID类型 (required)
     * @param  \SplFileObject $file 上传人群文件 (required)
     * @param  string $operationType 文件操作类型 (optional)
     * @param  string $saltId 数据加密的盐 id，当且仅当数据文件中的用户 id 类型为 &#39;SALTED_HASH_IMEI&#39; 或 &#39;SALTED_HASH_IDFA&#39; 时有效 (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function customAudienceFilesAddAsync($accountId, $audienceId, $userIdType, $file, $operationType = null, $saltId = null)
    {
        return $this->customAudienceFilesAddAsyncWithHttpInfo($accountId, $audienceId, $userIdType, $file, $operationType, $saltId)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation customAudienceFilesAddAsyncWithHttpInfo
     *
     * 上传客户人群数据文件
     *
     * @param  int $accountId 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id (required)
     * @param  int $audienceId 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得 (required)
     * @param  string $userIdType 号码包用户ID类型 (required)
     * @param  \SplFileObject $file 上传人群文件 (required)
     * @param  string $operationType 文件操作类型 (optional)
     * @param  string $saltId 数据加密的盐 id，当且仅当数据文件中的用户 id 类型为 &#39;SALTED_HASH_IMEI&#39; 或 &#39;SALTED_HASH_IDFA&#39; 时有效 (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function customAudienceFilesAddAsyncWithHttpInfo($accountId, $audienceId, $userIdType, $file, $operationType = null, $saltId = null)
    {
        $returnType = '\TencentAds\Model\CustomAudienceFilesAddResponse';
        $request = $this->customAudienceFilesAddRequest($accountId, $audienceId, $userIdType, $file, $operationType, $saltId);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'customAudienceFilesAdd'
     *
     * @param  int $accountId 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id (required)
     * @param  int $audienceId 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得 (required)
     * @param  string $userIdType 号码包用户ID类型 (required)
     * @param  \SplFileObject $file 上传人群文件 (required)
     * @param  string $operationType 文件操作类型 (optional)
     * @param  string $saltId 数据加密的盐 id，当且仅当数据文件中的用户 id 类型为 &#39;SALTED_HASH_IMEI&#39; 或 &#39;SALTED_HASH_IDFA&#39; 时有效 (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function customAudienceFilesAddRequest($accountId, $audienceId, $userIdType, $file, $operationType = null, $saltId = null)
    {
        // verify the required parameter 'accountId' is set
        if ($accountId === null || (is_array($accountId) && count($accountId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $accountId when calling customAudienceFilesAdd'
            );
        }
        // verify the required parameter 'audienceId' is set
        if ($audienceId === null || (is_array($audienceId) && count($audienceId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $audienceId when calling customAudienceFilesAdd'
            );
        }
        // verify the required parameter 'userIdType' is set
        if ($userIdType === null || (is_array($userIdType) && count($userIdType) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $userIdType when calling customAudienceFilesAdd'
            );
        }
        // verify the required parameter 'file' is set
        if ($file === null || (is_array($file) && count($file) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $file when calling customAudienceFilesAdd'
            );
        }

        $resourcePath = '/custom_audience_files/add';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // form params
        if ($accountId !== null) {
            $formParams['account_id'] = ObjectSerializer::toFormValue($accountId);
        }
        // form params
        if ($audienceId !== null) {
            $formParams['audience_id'] = ObjectSerializer::toFormValue($audienceId);
        }
        // form params
        if ($userIdType !== null) {
            $formParams['user_id_type'] = ObjectSerializer::toFormValue($userIdType);
        }
        // form params
        if ($file !== null) {
            $multipart = true;
            $formParams['file'] = \GuzzleHttp\Psr7\try_fopen(ObjectSerializer::toFormValue($file), 'rb');
        }
        // form params
        if ($operationType !== null) {
            $formParams['operation_type'] = ObjectSerializer::toFormValue($operationType);
        }
        // form params
        if ($saltId !== null) {
            $formParams['salt_id'] = ObjectSerializer::toFormValue($saltId);
        }
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json', 'application/xml']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            
            if($headers['Content-Type'] === 'application/json') {
                // \stdClass has no __toString(), so we should encode it manually
                if ($httpBody instanceof \stdClass) {
                    $httpBody = \GuzzleHttp\json_encode($httpBody);
                }
                // array has no __toString(), so we should encode it manually
                if(is_array($httpBody)) {
                    $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($httpBody));
                }
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('access_token');
        if ($apiKey !== null) {
            $queryParams['access_token'] = $apiKey;
        }
        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('nonce');
        if ($apiKey !== null) {
            $queryParams['nonce'] = $apiKey;
        }
        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('timestamp');
        if ($apiKey !== null) {
            $queryParams['timestamp'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation customAudienceFilesGet
     *
     * 获取客户人群数据文件
     *
     * @param  int $accountId 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id (required)
     * @param  int $audienceId 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得 (optional)
     * @param  int $customAudienceFileId 数据文件 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience_file/custom_audience_files_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audience_files]&lt;/a&gt; 模块上传客户人群数据文件获得 (optional)
     * @param  int $page 当前页码 (optional)
     * @param  int $pageSize 分页大小 (optional)
     * @param  string[] $fields 返回参数的字段列表 (optional)
     *
     * @throws \TencentAds\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \TencentAds\Model\CustomAudienceFilesList
     */
    public function customAudienceFilesGet($accountId, $audienceId = null, $customAudienceFileId = null, $page = null, $pageSize = null, $fields = null)
    {
        list($response) = $this->customAudienceFilesGetWithHttpInfo($accountId, $audienceId, $customAudienceFileId, $page, $pageSize, $fields);
        return $response;
    }

    /**
     * Operation customAudienceFilesGetWithHttpInfo
     *
     * 获取客户人群数据文件
     *
     * @param  int $accountId 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id (required)
     * @param  int $audienceId 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得 (optional)
     * @param  int $customAudienceFileId 数据文件 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience_file/custom_audience_files_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audience_files]&lt;/a&gt; 模块上传客户人群数据文件获得 (optional)
     * @param  int $page 当前页码 (optional)
     * @param  int $pageSize 分页大小 (optional)
     * @param  string[] $fields 返回参数的字段列表 (optional)
     *
     * @throws \TencentAds\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \TencentAds\Model\CustomAudienceFilesList, HTTP status code, HTTP response headers (array of strings)
     */
    public function customAudienceFilesGetWithHttpInfo($accountId, $audienceId = null, $customAudienceFileId = null, $page = null, $pageSize = null, $fields = null)
    {
        $returnType = '\TencentAds\Model\CustomAudienceFilesList';
        $request = $this->customAudienceFilesGetRequest($accountId, $audienceId, $customAudienceFileId, $page, $pageSize, $fields);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\TencentAds\Model\CustomAudienceFilesList',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation customAudienceFilesGetAsync
     *
     * 获取客户人群数据文件
     *
     * @param  int $accountId 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id (required)
     * @param  int $audienceId 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得 (optional)
     * @param  int $customAudienceFileId 数据文件 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience_file/custom_audience_files_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audience_files]&lt;/a&gt; 模块上传客户人群数据文件获得 (optional)
     * @param  int $page 当前页码 (optional)
     * @param  int $pageSize 分页大小 (optional)
     * @param  string[] $fields 返回参数的字段列表 (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function customAudienceFilesGetAsync($accountId, $audienceId = null, $customAudienceFileId = null, $page = null, $pageSize = null, $fields = null)
    {
        return $this->customAudienceFilesGetAsyncWithHttpInfo($accountId, $audienceId, $customAudienceFileId, $page, $pageSize, $fields)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation customAudienceFilesGetAsyncWithHttpInfo
     *
     * 获取客户人群数据文件
     *
     * @param  int $accountId 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id (required)
     * @param  int $audienceId 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得 (optional)
     * @param  int $customAudienceFileId 数据文件 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience_file/custom_audience_files_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audience_files]&lt;/a&gt; 模块上传客户人群数据文件获得 (optional)
     * @param  int $page 当前页码 (optional)
     * @param  int $pageSize 分页大小 (optional)
     * @param  string[] $fields 返回参数的字段列表 (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function customAudienceFilesGetAsyncWithHttpInfo($accountId, $audienceId = null, $customAudienceFileId = null, $page = null, $pageSize = null, $fields = null)
    {
        $returnType = '\TencentAds\Model\CustomAudienceFilesList';
        $request = $this->customAudienceFilesGetRequest($accountId, $audienceId, $customAudienceFileId, $page, $pageSize, $fields);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'customAudienceFilesGet'
     *
     * @param  int $accountId 推广帐号 id ，有操作权限的帐号 id，包括代理商和广告主帐号id (required)
     * @param  int $audienceId 人群 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience/custom_audiences_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audiences]&lt;/a&gt; 模块创建客户人群获得 (optional)
     * @param  int $customAudienceFileId 数据文件 id，通过 &lt;a href&#x3D;&#39;/docs/api/audiences/custom_audience_file/custom_audience_files_add&#39; target&#x3D;&#39;_blank&#39;&gt;[custom_audience_files]&lt;/a&gt; 模块上传客户人群数据文件获得 (optional)
     * @param  int $page 当前页码 (optional)
     * @param  int $pageSize 分页大小 (optional)
     * @param  string[] $fields 返回参数的字段列表 (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function customAudienceFilesGetRequest($accountId, $audienceId = null, $customAudienceFileId = null, $page = null, $pageSize = null, $fields = null)
    {
        // verify the required parameter 'accountId' is set
        if ($accountId === null || (is_array($accountId) && count($accountId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $accountId when calling customAudienceFilesGet'
            );
        }

        $resourcePath = '/custom_audience_files/get';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($accountId !== null) {
            $queryParams['account_id'] = ObjectSerializer::toQueryValue($accountId);
        }
        // query params
        if ($audienceId !== null) {
            $queryParams['audience_id'] = ObjectSerializer::toQueryValue($audienceId);
        }
        // query params
        if ($customAudienceFileId !== null) {
            $queryParams['custom_audience_file_id'] = ObjectSerializer::toQueryValue($customAudienceFileId);
        }
        // query params
        if ($page !== null) {
            $queryParams['page'] = ObjectSerializer::toQueryValue($page);
        }
        // query params
        if ($pageSize !== null) {
            $queryParams['page_size'] = ObjectSerializer::toQueryValue($pageSize);
        }
        // query params
        if (is_array($fields)) {
            $queryParams['fields'] = $fields;
        } else
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['text/plain']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            
            if($headers['Content-Type'] === 'application/json') {
                // \stdClass has no __toString(), so we should encode it manually
                if ($httpBody instanceof \stdClass) {
                    $httpBody = \GuzzleHttp\json_encode($httpBody);
                }
                // array has no __toString(), so we should encode it manually
                if(is_array($httpBody)) {
                    $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($httpBody));
                }
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('access_token');
        if ($apiKey !== null) {
            $queryParams['access_token'] = $apiKey;
        }
        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('nonce');
        if ($apiKey !== null) {
            $queryParams['nonce'] = $apiKey;
        }
        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('timestamp');
        if ($apiKey !== null) {
            $queryParams['timestamp'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
