<?php
/**
 * OauthTokenResponseData
 *
 * PHP version 5
 *
 * @category Class
 * @package  TencentAds
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Marketing API
 *
 * Marketing API
 *
 * OpenAPI spec version: 1.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.4.13
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace TencentAds\Model;

use \ArrayAccess;
use \TencentAds\ObjectSerializer;

/**
 * OauthTokenResponseData Class Doc Comment
 *
 * @category Class
 * @package  TencentAds
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class OauthTokenResponseData implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'OauthTokenResponse_data';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'authorizerInfo' => '\TencentAds\Model\OauthAuthorizerStruct',
        'accessToken' => 'string',
        'refreshToken' => 'string',
        'accessTokenExpiresIn' => 'int',
        'refreshTokenExpiresIn' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'authorizerInfo' => null,
        'accessToken' => null,
        'refreshToken' => null,
        'accessTokenExpiresIn' => 'int64',
        'refreshTokenExpiresIn' => 'int64'
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'authorizerInfo' => 'authorizer_info',
        'accessToken' => 'access_token',
        'refreshToken' => 'refresh_token',
        'accessTokenExpiresIn' => 'access_token_expires_in',
        'refreshTokenExpiresIn' => 'refresh_token_expires_in'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'authorizerInfo' => 'setAuthorizerInfo',
        'accessToken' => 'setAccessToken',
        'refreshToken' => 'setRefreshToken',
        'accessTokenExpiresIn' => 'setAccessTokenExpiresIn',
        'refreshTokenExpiresIn' => 'setRefreshTokenExpiresIn'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'authorizerInfo' => 'getAuthorizerInfo',
        'accessToken' => 'getAccessToken',
        'refreshToken' => 'getRefreshToken',
        'accessTokenExpiresIn' => 'getAccessTokenExpiresIn',
        'refreshTokenExpiresIn' => 'getRefreshTokenExpiresIn'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['authorizerInfo'] = isset($data['authorizerInfo']) ? $data['authorizerInfo'] : null;
        $this->container['accessToken'] = isset($data['accessToken']) ? $data['accessToken'] : null;
        $this->container['refreshToken'] = isset($data['refreshToken']) ? $data['refreshToken'] : null;
        $this->container['accessTokenExpiresIn'] = isset($data['accessTokenExpiresIn']) ? $data['accessTokenExpiresIn'] : null;
        $this->container['refreshTokenExpiresIn'] = isset($data['refreshTokenExpiresIn']) ? $data['refreshTokenExpiresIn'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets authorizerInfo
     *
     * @return \TencentAds\Model\OauthAuthorizerStruct
     */
    public function getAuthorizerInfo()
    {
        return $this->container['authorizerInfo'];
    }

    /**
     * Sets authorizerInfo
     *
     * @param \TencentAds\Model\OauthAuthorizerStruct $authorizerInfo authorizer_struct
     *
     * @return $this
     */
    public function setAuthorizerInfo($authorizerInfo)
    {
        $this->container['authorizerInfo'] = $authorizerInfo;

        return $this;
    }

    /**
     * Gets accessToken
     *
     * @return string
     */
    public function getAccessToken()
    {
        return $this->container['accessToken'];
    }

    /**
     * Sets accessToken
     *
     * @param string $accessToken access_token
     *
     * @return $this
     */
    public function setAccessToken($accessToken)
    {
        $this->container['accessToken'] = $accessToken;

        return $this;
    }

    /**
     * Gets refreshToken
     *
     * @return string
     */
    public function getRefreshToken()
    {
        return $this->container['refreshToken'];
    }

    /**
     * Sets refreshToken
     *
     * @param string $refreshToken refresh_token
     *
     * @return $this
     */
    public function setRefreshToken($refreshToken)
    {
        $this->container['refreshToken'] = $refreshToken;

        return $this;
    }

    /**
     * Gets accessTokenExpiresIn
     *
     * @return int
     */
    public function getAccessTokenExpiresIn()
    {
        return $this->container['accessTokenExpiresIn'];
    }

    /**
     * Sets accessTokenExpiresIn
     *
     * @param int $accessTokenExpiresIn access_token_expires_in
     *
     * @return $this
     */
    public function setAccessTokenExpiresIn($accessTokenExpiresIn)
    {
        $this->container['accessTokenExpiresIn'] = $accessTokenExpiresIn;

        return $this;
    }

    /**
     * Gets refreshTokenExpiresIn
     *
     * @return int
     */
    public function getRefreshTokenExpiresIn()
    {
        return $this->container['refreshTokenExpiresIn'];
    }

    /**
     * Sets refreshTokenExpiresIn
     *
     * @param int $refreshTokenExpiresIn refresh_token_expires_in
     *
     * @return $this
     */
    public function setRefreshTokenExpiresIn($refreshTokenExpiresIn)
    {
        $this->container['refreshTokenExpiresIn'] = $refreshTokenExpiresIn;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


