<?php
/**
 * TargetingGeoLocations
 *
 * PHP version 5
 *
 * @category Class
 * @package  TencentAds
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Marketing API
 *
 * Marketing API
 *
 * OpenAPI spec version: 1.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.4.13
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace TencentAds\Model;

use \ArrayAccess;
use \TencentAds\ObjectSerializer;

/**
 * TargetingGeoLocations Class Doc Comment
 *
 * @category Class
 * @description 地理位置定向
 * @package  TencentAds
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class TargetingGeoLocations implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'targeting_geo_locations';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'locationTypes' => 'string[]',
        'regions' => 'int[]',
        'businessDistricts' => 'int[]',
        'customLocations' => '\TencentAds\Model\TargetingCustomLocationsItem[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'locationTypes' => null,
        'regions' => 'int64',
        'businessDistricts' => 'int64',
        'customLocations' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'locationTypes' => 'location_types',
        'regions' => 'regions',
        'businessDistricts' => 'business_districts',
        'customLocations' => 'custom_locations'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'locationTypes' => 'setLocationTypes',
        'regions' => 'setRegions',
        'businessDistricts' => 'setBusinessDistricts',
        'customLocations' => 'setCustomLocations'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'locationTypes' => 'getLocationTypes',
        'regions' => 'getRegions',
        'businessDistricts' => 'getBusinessDistricts',
        'customLocations' => 'getCustomLocations'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['locationTypes'] = isset($data['locationTypes']) ? $data['locationTypes'] : null;
        $this->container['regions'] = isset($data['regions']) ? $data['regions'] : null;
        $this->container['businessDistricts'] = isset($data['businessDistricts']) ? $data['businessDistricts'] : null;
        $this->container['customLocations'] = isset($data['customLocations']) ? $data['customLocations'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets locationTypes
     *
     * @return string[]
     */
    public function getLocationTypes()
    {
        return $this->container['locationTypes'];
    }

    /**
     * Sets locationTypes
     *
     * @param string[] $locationTypes locationTypes
     *
     * @return $this
     */
    public function setLocationTypes($locationTypes)
    {
        $this->container['locationTypes'] = $locationTypes;

        return $this;
    }

    /**
     * Gets regions
     *
     * @return int[]
     */
    public function getRegions()
    {
        return $this->container['regions'];
    }

    /**
     * Sets regions
     *
     * @param int[] $regions regions
     *
     * @return $this
     */
    public function setRegions($regions)
    {
        $this->container['regions'] = $regions;

        return $this;
    }

    /**
     * Gets businessDistricts
     *
     * @return int[]
     */
    public function getBusinessDistricts()
    {
        return $this->container['businessDistricts'];
    }

    /**
     * Sets businessDistricts
     *
     * @param int[] $businessDistricts businessDistricts
     *
     * @return $this
     */
    public function setBusinessDistricts($businessDistricts)
    {
        $this->container['businessDistricts'] = $businessDistricts;

        return $this;
    }

    /**
     * Gets customLocations
     *
     * @return \TencentAds\Model\TargetingCustomLocationsItem[]
     */
    public function getCustomLocations()
    {
        return $this->container['customLocations'];
    }

    /**
     * Sets customLocations
     *
     * @param \TencentAds\Model\TargetingCustomLocationsItem[] $customLocations customLocations
     *
     * @return $this
     */
    public function setCustomLocations($customLocations)
    {
        $this->container['customLocations'] = $customLocations;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


